/*
 * V12.C
 *
 *      The idea behind this module is to manage the text buffer
 *      as external blocks. For speed, these blocks are kept in
 *      main memory. Code must provide fast copies to and from the
 *      main text buffer, and of course, fast loads from disk.
 */
#include "v.h"

#if TURBOC
#pragma inline
void CPfromBLOCK(I,P,n) int I; char *P; int n;{
/* This code by Steve Worcester, Nov 1988 */
getmemblock(I);         /* Load external block to low memory */
#if 0
asm     mov     ax,es   /* save es and ds */
asm     mov     dx,ds
asm     mov     cx,n    /* count */
asm     mov     bx,I    /* offset into memblock[] */
asm     shl     bx,1    /* element width 4 */
asm     shl     bx,1
asm     add     bx,word ptr DGROUP:_memblock
asm     mov     di,P    /* dest is es:di */
asm     lds     si,dword ptr [bx]  /* source ds:si */
asm     mov     es,dx   /* swap in segment for dest */
asm     cld
asm     rep     movsb   /* move it all */
asm     mov     ds,dx   /* restore ds */
asm     mov     es,ax   /* restore es */
#else
asm     push    es
asm     push    ds
asm     mov     dx,ds
asm     mov     ax,I    /* offset into memblock[] */
asm     shl     ax,1    /* element width 4 */
asm     shl     ax,1
asm     les     bx,dword ptr DGROUP:_memblock
asm     add     bx,ax
asm     lds     si,dword ptr es:[bx]  /* source ds:si */
asm     mov     di,P    /* dest is es:di */
asm     mov     es,dx   /* swap in segment for dest */
asm     mov     cx,n    /* count */
asm     cld
asm     rep     movsb   /* move it all */
asm     pop     ds
asm     pop     es
#endif
}

#if 0
/* This routine requires a block move of the data before the copy */
/* in order to succeed. The problem is that dest[] and src[] must */
/* be so many chars apart for this to work. */
void slowkillcrlf(dest,src,nlines,nbytes,splits)
char far *dest; char far *src;
int *nlines,*nbytes,*splits;
{
extern int intexttype;
register int x,nbyte;
int nline;
int lc;
register char far *s;
register char far *d;
extern int MAXLN;

    d=dest; s=src;
    lc=MAXLN-1; nbyte=nbytes[0];
    s[nbyte]=26; /* 26 chosen because it's not equal to 13, 10, 0, 255 */
    nline=0;
    while(nbyte-- > 0){
      x=(s[0]);
      /* Read MSDOS, MAC, UNIX files by default */
sk1:
      if(x==13){
        x=s[1];           /* works because s[nbyte]==26 */
        if(x==0 || x==10) {++s; --nbyte;}
        goto newline;
      }
sk2:
      if(x==0 || x== 10) {
newline: *d++ = 0; ++s; lc=MAXLN-1; ++nline; continue;
      }
sk3:
      if(!lc) {
splitline:  *d++ = 0; ++nline; *d++ = 2; lc=MAXLN-1-1; splits[0] += 1;
      }
sk4:
      *d++ = *s++; --lc;
    }
    nbytes[0]=((int)(d-dest)); nlines[0]=nline;
}
#endif

#if 1
void slowkillcrlf(dest,src,nlines,nbytes,splits)
char far *dest; char far *src;
int *nlines,*nbytes,*splits;
{
int dsreg;
/*extern int MAXLN;*/
  asm   mov     cx,MAXLN        /* cx == MAXLN-1 */
  asm   dec     cx                              /* cx=MAXLN-1 */
  asm   mov     bx,nbytes
  asm   mov     dx,word ptr [bx]                /* dx==number of bytes*/
  asm   les     di,src
  asm   add     di,dx
  asm   mov     byte ptr es:[di],26             /*  src[nbytes]=26; */
  asm   les     di,dest                         /* di=dest */
  asm   xor     bx,bx                           /* nlines=0; line count */
  asm   push    ds
  asm   push    bx
  asm   push    cx
  asm   lds     si,src                          /* si=src */
slowloop:
/* while(nbyte-- > 0) */
  asm   or      dx,dx                           /* test nbyte-- == 0 */
  asm   je      slowkillquit
  asm   dec     dx                      /* --nbyte */
  asm   mov     al,byte ptr ds:[si]     /* al == s[0] */
  asm   mov     ah,al
/*  if(x==13){if(s[1]==0 || s[1]==10) {++s; --nbytes;}; goto newline;}*/
/*  This works because s[nbytes]==26 */
sk1:
/*  if(x==13){ */
  asm   cmp     al,13
  asm   jne     sk2                     /* Go test 0, 10 */
/*  if(s[1]==0 || s[1]==10) */
  asm   inc     si                      /* ++s */
  asm   mov     al,byte ptr ds:[si]     /* Works because s[nbytes]==26 */
  asm   cmp     al,10                   /* s[1] == 10? */
  asm   je      slowkill4
  asm   cmp     al,0                    /* s[1]==0? */
  asm   je      slowkill4
  asm   dec     si
  asm   jmp     short newline           /* got a line with CR only   */
/* if(x==0||x==10){*dest++ =0; ++src; lc=MAXLN-1; ++nlines; continue;} */
slowkill4:
  asm   or      dx,dx                   /* Only decrement dx if dx>0 */
  asm   je      newline
  asm   dec     dx
newline:
  asm   mov     byte ptr es:[di],0
  asm   inc     di              /* *dest++ = 0 */
  asm   inc     si              /* ++src; */
  asm   pop     cx              /* cx == MAXLN-1 */
  asm   push    cx
  asm   inc     bx              /* count lines */
  asm   jmp     slowloop
sk2:
  asm   cmp     al,10           /* x == 10 */
  asm   je      newline
  asm   cmp     al,0            /* x==0 */
  asm   je      newline
/* if(!lc) {*dest++ =0; ++nlines; *dest++ =2; lc=MAXLN-1-1; splits[0]+=1;} */
sk3:
  asm   mov     byte ptr es:[di],ah
  asm   or      cx,cx
  asm   jne     sk4                     /* No, then continue... */
  asm   mov     byte ptr es:[di],0      /* break the line */
  asm   inc     di
  asm   inc     bx
  asm   mov     byte ptr es:[di],2      /* Marker is ctrl-B */
  asm   inc     di
  asm   mov     byte ptr es:[di],ah
  asm   pop     cx                      /* cx == MAXLN-1 */
  asm   pop     ax
  asm   inc     ax                      /* splits[0] += 1 */
  asm   push    ax
  asm   push    cx
  asm   dec     cx                      /* lc = MAXLN-2 */
/*  *d++ = *s++; --lc; */
sk4:
  asm   inc     di                      /* *dest++ = *src++ */
  asm   inc     si
  asm   dec     cx                      /* --lc */
  asm   jmp     slowloop

slowkillquit:
  asm   pop     cx
  asm   pop     dx
  asm   pop     ds
  asm   mov     ax,bx
  asm   mov     bx,nlines
  asm   mov     word ptr [bx],ax        /* return nlines[0]==ax */
  asm   mov     bx,splits
  asm   mov     ax,word ptr [bx]
  asm   add     ax,dx
  asm   mov     word ptr [bx],ax        /* splits[0] updated */
  asm   mov     ax,di                   /* nbytes=((int)(dest-destbase)); */
  asm   les     di,dest
  asm   sub     ax,di
  asm   mov     bx,nbytes
  asm   mov     word ptr [bx],ax        /* return nbytes[0]==ax */
}
#endif


#if 0
/* For MAC or UNIX files, only one pass is needed for a text file, */
/* in whihc the line terminator is replaced by NULL. */
/* The routine fails if another end of line char is found, unless */
/* it happens to be '\r' and the file type is supposed to be CRLF. */
/* On success, for a CRLF file, it calls dropCRnull() to remove the */
/* CR+NULL combinations (a little slow). */
int killcrlf(buf,nlines,nbytes)
char far *buf;
int *nlines,*nbytes;
{
extern int MAXLN;
extern int intexttype;
register int i,j;
char f,g,flag,x;
extern void dropCRnull();

  i=nbytes[0];
  nlines[0]=0;
  flag = (intexttype==CRLFtexttype);
  f='\n'; g='\r';
  if(intexttype==CRtexttype) {f='\r'; g='\n';}
  while(i--){
    if((buf[i]) != f) goto quit;           /* Wrong end of line char */
    buf[i]=0;                              /* End of line == NULL */
    nlines[0] += 1;                        /* Count lines */
    j=i;
    while(i){
      if((x=buf[i-1])==0) goto quit;       /* BINARY file? */
      if(flag==0 && x==g) goto quit;       /* Wrong file type? */
      if(x==f) break;                      /* Found end of line */
      --i;
      if(j-i >= MAXLN) goto quit;          /* Long line */
    }
  }
  if(flag) dropCRnull(buf,nbytes);         /* Low overhead for DOS */
  return 1;                                /* It worked. */
quit:
  return 0;                                /* It failed. */
}

/* This routine is only applied in case proc killcrlf() was a */
/* success **AND** the file type is CRLF.  It copies the block */
/* over itself, folding out the extra CR's, assuming all LF's */
/* have been replaced by NULL. */
void dropCRnull(dest,nbytes) char far *dest; int *nbytes; {
int n,m; char far *s; char far *d;
  m=nbytes[0]; n=0; s=d=dest;
  while(m--){
   if((*d++ = *s++)!=0) ++n;
   else {
     if(n){ /* Then 2 chars were copied, last was a null */
       if(d[-2]==13){d[-2]=0; --d;} /* Make 2 nulls, copy over second */
       n=0;
     }
   }
  }
  nbytes[0]=(int)(d-dest);
}
#endif

int CPtoBLOCK(I,P,n) int I; char *P; int n;{
/* Following code by Steve Worcester, Nov 1988 */
/* MOVE BLOCK */
getmemblock(I);         /* Load external block to low memory */
#if 0
asm     mov     dx,es
asm     mov     bx,I
asm     shl     bx,1
asm     shl     bx,1
asm     add     bx,word ptr DGROUP:_memblock
asm     les     di,dword ptr [bx]
asm     mov     si,P
asm     mov     cx,n
asm     cld
asm     rep     movsb
asm     mov     es,dx
#else
asm     push    es
asm     push    ds
asm     mov     dx,ds
asm     mov     ax,I
asm     shl     ax,1
asm     shl     ax,1
asm     lds     bx,dword ptr DGROUP:_memblock
asm     add     bx,ax
asm     les     di,dword ptr ds:[bx]
asm     mov     si,P
asm     mov     ds,dx
asm     mov     cx,n
asm     cld
asm     rep     movsb
asm     pop     ds
asm     pop     es
#endif
/* COUNT NULLS */
asm     push    es      /* save es */
asm     mov     ax,ds   /* scas uses es:di */
asm     mov     es,ax   /* es=ds */
asm     xor     al,al   /* al=byte to be matched */
asm     xor     dx,dx   /* dx=match counter */
asm     mov     di,P    /* di=base address to search */
asm     mov     cx,n    /* cx=number of bytes to search */
CPtloop:
asm     repnz   scasb   /* scan until cx=0 or [di] == al */
asm     inc     dx      /* increment null count */
asm     or      cx,cx   /* test cx=0 */
asm     jnz     CPtloop /* no, then loop */
asm     dec     di      /* yes, then check last byte == al */
asm     cmp     byte ptr [di],al
asm     jz      CPtend  /* Matched, correct count in dx */
asm     dec     dx      /* else adjust counter by 1 */
CPtend:
asm     pop     es      /* restore es to match entry */
asm     mov     ax,dx   /* return count of nulls */
return (_AX);
}

/* copy one segment to another, no overlap troubles */
void segcopy(d,s,n)
char far *d;
char far *s;
int n;
{
if(n==0) return;
if(d <= s || s+n <= d){
asm     mov     bx,ds
asm     mov     dx,es
asm     les     di,d            /* dest = es:di */
asm     lds     si,s            /* src = ds:si */
asm     mov     cx,n            /* count to move */
asm     cld
asm     rep     movsb           /* move it all */
asm     mov     ds,bx
asm     mov     es,dx
}
else {
asm     mov     bx,ds
asm     mov     dx,es
asm     les     di,d            /* dest = es:di */
asm     lds     si,s            /* src = ds:si */
asm     mov     cx,n            /* count to move */
asm     add     si,cx
asm     add     di,cx
asm     dec     si
asm     dec     di              /* move backwards */
asm     std
asm     rep     movsb           /* move it all */
asm     cld
asm     mov     ds,bx
asm     mov     es,dx
}
}

/* Read in a block off disk to far pointer memory */
int eread(fd, buf, len)
int     fd;
char  far *buf;
int     len;
{
asm     mov     ax,ds
asm     mov     cx,len
asm     mov     bx,fd
asm     lds     dx,dword ptr buf
asm     push ax /* save ds */
asm     mov     ah,3fh
asm     int     21h
asm     pop     ds      /* restore ds */
asm     jc      readerr
return (_AX);
readerr:
return (-1);
}

/* Write far pointer memory to disk */
int ewrite(fd, buf, len)
int     fd;
char  far *buf;
int     len;
{
asm     mov     ax,ds
asm     mov     cx,len
asm     mov     bx,fd
asm     lds     dx,dword ptr buf
asm     push    cx
asm     push ax /* save ds */
asm     mov     ah,40h
asm     int     21h
asm     pop     ds      /* restore ds */
asm     pop     cx      /* Amt we were supposed to write */
asm     jc      error
asm     cmp     ax,cx
asm     je      quit
error:
asm     mov     ax,-1
quit:;
return (_AX);
}

#endif

#if BSDunix || SYS5 || (TURBOC && !UseXMS)
/*
 * getmemblock(n)  -- get address of memory block
 */
char far *getmemblock(n) int n; {
/* extern char far **memblock; */
  return memblock[n];
}

/*
 *      Create block by OS function call. Return record
 *         I on success, -1 on failure.
 *
 */
int crBLOCK(){
register int i,j;

  for(i=0;i<MAXBLOCK;++i) {
/*    if((j=memmark[i]) == 2) continue; */
    if((j=memmark[i]) == 1) goto remark; /* re-use free block */
    if(j == 0) {
#if !TURBOC
extern void * malloc();
      if((memblock[i]=(char far *)malloc((int)SIZEBLOCK))==0) goto quit;
#endif
#if TURBOC
extern int STASHmin;
      if((long)STASHmin*SIZEBLOCK>farcoreleft()) goto quit;
      if((memblock[i]=farmalloc((unsigned long)SIZEBLOCK))==0) goto quit;
#endif
      goto remark;
    }
  }
quit:
  return -1;
remark:
      memmark[i]=2; ++USEDBLOCK; return i;
}

/*
 *      Release block I. Return 0
 *         on success, nonzero on failure,
 *
 */
int rlBLOCK(I) unsigned I;{
  if(I<MAXBLOCK && memmark[I] ==2){
    --USEDBLOCK; memmark[I]=1; return 0;
  }
  return -1; /* failed */
}

void XMSinit(){      /* Used in v0.c */
    MAXBLOCK=MAXXMS;
#if MSDOS               /* No XMS memory, using only 640k */
    /* Only main memory can be used for blocks */
    MAXBLOCK=min((int)(farcoreleft()/SIZEBLOCK),MAXBLOCK);
#endif
    MAXBLOCK=max(5,MAXBLOCK);   /* Sanity check, zero blocks can't work */
}
void XMSfree(){}     /* Used at exit; see v9.c */
#endif

#if (TURBOC && UseXMS)

#define XGetVersion     00h   /* commands to the XMS driver*/
#define XRequestHMA     01h
#define XReleaseHMA     02h
#define XGlobalE20      03h
#define XGlobalD20      04h
#define XLocalE20       05h
#define XLocalD20       06h
#define XQuery20        07h
#define XGetMemSize     08h
#define XAllocEMB       09h
#define XFreeEMB        0ah
#define XMoveEMB        0bh
#define XLockEMB        0ch
#define XUnlockEMB      0dh
#define XGetHandleInfo  0eh
#define XReallocEMB     0fh
#define XRequestUMB     10h
#define XReleaseUMB     11h

#define ENone           00h            /* "no error" error code */
#define ENotInitd       01h            /* XMSSetup was never  */
                                        /* called before other XMS funcs */

struct EMMMoveStruct {
unsigned long TransferLength; /* 32-bit number of bytes to transfer */
unsigned      SourceHandle;   /* Handle of source block */
unsigned long SourceOffset;   /* 32-bit offset into source block */
unsigned      DestHandle;     /* Handle of dest block */
unsigned long DestOffset;     /* 32-bit offset into dest block */
};

unsigned XMSInitd=0;    /* Flag which detects presence of XMS */
unsigned freeXMSblk=0;  /* Amount of largest free XMS block in kilobytes */
unsigned freeXMSmem=0;  /* Amount of free XMS memory in kilobytes */
int SWAPBL=0;
unsigned long XMSDriver=0;   /* far address of XMS driver */

struct EMMMoveStruct moverec; /* extended memory move          */

void XMS_Setup(){
asm     mov     ax,4300h                /* XMS Driver installation check */
asm     int     2fh
asm     cmp     al,80h                  /* returns 80h if installed */
asm     mov     ax,0                    /* XMS Driver not present */
asm     jne     short exit
asm     mov     ax,4310h                /* get address of XMS driver */
asm     int     2fh
asm     mov     word ptr _XMSDriver,bx            /* store offset */
asm     mov     word ptr _XMSDriver+2,es          /* store segment */
asm     mov     ax,1
exit:
asm     mov     XMSInitd,ax              /* 0=No Init, 1=Init */
}

int XMS_LargestFreeBlock(freeblk,freemem)
unsigned int *freeblk,*freemem;
{
asm     cmp     XMSInitd,0              /* has XMSSetup been called? */
asm     mov     al,ENotInitd            /* no, return error code */
asm     je      short exit
hasinitd:
asm     mov     ah,XGetMemSize          /* function to get free/total memory */
asm     call    dword ptr _XMSDriver    /* call the XMS driver */
asm     push    bx
asm     mov     bx,freeblk
asm     mov     word ptr [bx],ax
asm     mov     bx,freemem
asm     mov     word ptr [bx],dx
asm     pop     ax                      /* XMS error code to al */
exit:
asm     mov     ah,0
return (_AX);
}

unsigned XMS_AllocEMB(mysize,handle)
unsigned int mysize; unsigned int *handle;
{
asm     cmp     XMSInitd,0              /* has XMSSetup been called? */
asm     mov     al,ENotInitd            /* no, return error code */
asm     jz      short exit
asm     mov     ah,XAllocEMB            /* function code */
asm     mov     dx,mysize               /* number of kb to allocate */
asm     call    dword ptr _XMSDriver    /* call the XMS driver */
asm     or      ax,ax
asm     mov     al,bl                   /* bl==error code */
asm     jz      exit
asm     mov     bx,handle
asm     mov     word ptr [bx],dx        /* dx == handle */
asm     xor     al,al
exit: ;
asm     mov     ah,0
return (_AX);
}

int XMS_MoveEMB()
{
extern struct EMMMoveStruct moverec; /* extended memory move          */
asm     cmp     XMSInitd,0              /* has XMSSetup been called? */
asm     mov     al,ENotInitd            /* no, return error code */
asm     jz      short exit
hasinitd:
asm     mov     ah,XMoveEMB             /* function code */
asm     mov     si,offset moverec       /* Offset to si, segment is ds:*/
asm     call    dword ptr _XMSDriver    /* call the XMS driver */
asm     or      ax,ax
asm     mov     al,bl                   /* transfer XMS error code to al */
asm     jz      exit
asm     xor     al,al
exit:
asm     mov     ah,0
return (_AX);
}

int XMS_FreeEMB(handle)
unsigned int handle;
{
asm     cmp     XMSInitd,0              /* has XMSSetup been called? */
asm     mov     al,ENotInitd            /* no, return error code */
asm     je     short exit
hasinitd:
asm     mov     ah,XFreeEMB             /* function code */
asm     mov     dx,handle               /* handle number to free */
asm     call    dword ptr _XMSDriver    /* call the XMS driver */
asm     or      ax,ax
asm     mov     al,bl                   /* XMS error code to al */
asm     jz      exit
asm     xor     al,al
exit:
asm     mov     ah,0
return (_AX);
}

/*
 *      Release block I. Return 0
 *         on success, nonzero on failure,
 *
 */
int rlBLOCK(I) unsigned I;{
  if(I<=MAXBLOCK && memmark[I] ==2){
    --USEDBLOCK; memmark[I]=1; return 0;
  }
  return -1;
}

/*
 * getmemblock(n)  -- get address of memory block in low memory.
 * This routine has to succeed, it is not allowed to fail.
 */
char far *getmemblock(n) int n; {
int M;
  if(handles[n]==0) goto quit;
  if((M=crBLOCK()) == -1) goto noblock;
  XMSmoveblock(M,n);  /* Copy XMS block to low memory block. */
  swapblockP(M,n);    /* Swap pointers. Block n is low, block M is xms */
  rlBLOCK(M); /* Release the XMS block. It doesn't affect block n. */
  goto quit;  /* Return the low memory address */

noblock:
  M=getfirstused(2);
  XMSmoveblock(SWAPBL,M);  /* Copy block M to block SWAPBL. Now M is free. */
  XMSmoveblock(M,n);       /* Copy block n to block M. Now n is free. */
  swapblockP(n,M);         /* Swap pointers. Block M is xms, block n is low. */
  swapblockP(SWAPBL,M);    /* Swap pointers. Blocks SWAPBL snd M are xms. */
                           /* Data in M unchanged. Data in n unchanged. */
quit:
  return memblock[n]; /* Return the low memory address */
}

/*
 *      Create block by function call. Return record
 *      I on success, -1 on failure.
 *      Always sets memmark[I]==2 on success.
 *      WARNING: Two calls to crBLOCK might swap out the first
 *               block to XMS memory.
 *      To ***lock*** this block
 *      temporarily, set memmark[I]=3 after the call, then reset
 *      back to memmark[I]=2 before calling rlBLOCK(I).
 */
int crBLOCK(){
int i,j;
char far *tmp; unsigned handle;
extern int STASHmin;
static char washere=0;
  if((i=getfirstused(1)) != -1) goto worked; /* Re-use low memory? */
  if((i=getfirstused(0)) != -1){  /* Use new low memory block? */
      if((long)STASHmin*SIZEBLOCK <= farcoreleft()){
      if((memblock[i]=farmalloc((unsigned long)SIZEBLOCK))!=0)
        goto worked;
      }
  }
  if(!washere) {
    XMSloadSWAPBL();    /* Set up XMS swap block */
    washere=1;          /* Do it only once. */
  }
  for(i=0;i<MAXBLOCK;++i){ /* Re-use an old XMS block? */
    if(memmark[i]==1 && handles[i]!=0) goto swapxms;
  }
  if((i=getfirstused(0))!= -1){ /* Create a new XMS block? */
      if(get_XMS_block(i,SIZEKBLOCK)) goto failed;
      goto swapxms;
  }
failed:
  return -1;
swapxms:
  j=getfirstused(2);    /* Get first used low memory block j */
  XMSmoveblock(i,j);    /* Move data in block j to empty XMS block i */
  swapblockP(i,j);      /* Swap pointers in the two blocks */
  /* Now block j points to XMS, block i is low mem */
worked:
  handles[i]=0; /* Using low memory block */
  memmark[i]=2; ++USEDBLOCK;
  return i;
}

/* Return low memory index or unused array index */
getfirstused(x) int x; {
int i;
  for(i=0;i<MAXBLOCK;++i) {
    if(memmark[i]==0){ if(x==0) return i; break; }
    if(memmark[i]==x && handles[i]==0) return i; /* low block index */
  }
return -1;
}

void XMSmoveblock(dest,src) int dest,src; {
extern struct EMMMoveStruct moverec; /* extended memory move          */
/* copy low block to extended memory */
    moverec.TransferLength = SIZEBLOCK;
    moverec.SourceHandle = handles[src];   /* handle of 0 means direct memory */
    moverec.SourceOffset = (unsigned long)memblock[src];
    moverec.DestHandle = handles[dest];    /* the XMS handle */
    moverec.DestOffset=(unsigned long)memblock[dest];
#if 0
    if(XMS_MoveEMB()){
     char **msg={"XMS move error","Send email to GBG",0};
      WarningMessage(msg);
    }
#else
    XMS_MoveEMB();
#endif
}

void swapblockP(n,i) int n,i; {
char far *tmp; unsigned int x;
  tmp=memblock[i]; memblock[i]=memblock[n]; memblock[n]=tmp;
  x=handles[i]; handles[i]=handles[n]; handles[n]=x;
}

int get_XMS_block(n,amount)
    int n;                      /* Index into handles[], memblock[] */
    unsigned int amount;        /* Amount to allocate*/
{
static unsigned int blocksize= 0;
static unsigned int lasthandle= -1;
static unsigned long lastoffset=0;
unsigned x;
extern unsigned XMS_AllocEMB();

/* Nonzero blocksize? */
if(blocksize != 0){
  if(amount <=blocksize){
    handles[n]=lasthandle;
    goto success;
  } else blocksize=0;
}
if(blocksize == 0){
    if(XMS_LargestFreeBlock(&freeXMSblk,&freeXMSmem)) goto fail;
    if(amount>freeXMSblk) goto fail;
    blocksize=min(max((freeXMSmem >> 3),amount),MAXXMS);
    blocksize=min(blocksize,freeXMSblk);
    if(XMS_AllocEMB(blocksize,&x)){  /* allocate memory */
       if(XMS_AllocEMB(blocksize=freeXMSblk,&x)) goto fail;
    }
    lasthandle=handles[n]=x;
    lastoffset=0;
    goto success;
}

fail: blocksize=0; return(1);
success:
    memblock[n]=(char far *)lastoffset;
    lastoffset += 1024L*amount;
    blocksize -= amount;
return(0);
}

int XMSinit() {
static char washere=0;
extern char *core();
extern unsigned freeXMSmem,freeXMSblk;
    if(washere) goto quit;
    washere=1;
    XMS_Setup();
    /* XMSInitd */    /* Flag which detects presence of XMS */
    /* XMS_Setup must be called before using any other XMS function */
    if(XMSInitd){
        XMS_LargestFreeBlock(&freeXMSblk,&freeXMSmem);
        MAXBLOCK += min(MAXXMS,freeXMSmem/SIZEKBLOCK);
    }
    SWAPBL=MAXBLOCK-1;
#if 0
    handles=(unsigned far *)core(sizeof(unsigned int)*MAXBLOCK);
#else
    handles=farmalloc((unsigned long)sizeof(unsigned int)*MAXBLOCK);
#endif
quit:
    return XMSInitd;
}

void XMSloadSWAPBL(){        /* Save one xms block for swapping */
    if(XMSInitd){
       if(get_XMS_block(SWAPBL,SIZEKBLOCK)==0){
         --MAXBLOCK; memmark[SWAPBL]=2;
       }  else XMSInitd=0;
    }
}


void XMSfree(){
int j;
  if(XMSInitd){
    for(j=0;j<=MAXBLOCK;++j){
      XMS_FreeEMB(handles[j]); /* free memory */
    }
  }
}
#endif

/*
 *      Copy n bytes from block I to pointer p. Always
 *         works. Returns nothing.
 *
 */
#if BSDunix || SYS5
void CPfromBLOCK(II,P,n) int II; char *P; int n;{
#if SEGMEMORY
register char far *q; register int i;
  q=getmemblock(II);
  for(i=0;i<n;++i) P[i]=q[i];
#endif
#if !SEGMEMORY
#if !HASMEMCPY
  moveMEM(P,getmemblock(II),n);
#endif
#if HASMEMCPY
char *memcpy();
  memcpy(P,getmemblock(II),n);
#endif
#endif
}
#endif

/*
 *      Copy n bytes to block I from pointer P. Always
 *         works. Returns number of nulls found during
 *         transfer.
 *
 */
#if BSDunix || SYS5
/* C code seems to be slow */
int CPtoBLOCK(II,P,n) int II; char *P; int n;{
#if HASMEMCPY
register char *r; register int i,j;
char *memcpy();
  memcpy(getmemblock(II),r=P,i=n);
  j=0; while(i--) if(*r++ == 0) ++j;
#endif
#if !HASMEMCPY
register char far *q; register char *r; register int i,j;
  q=getmemblock(II); r=P;
  i=n; j=0;
  while(i--) if((*q++ = *r++)==0) ++j;
#endif
  return j;
}
#endif

#if BSDunix || SYS5
/* This routine requires a block move of the data before the copy */
/* in order to succeed. The problem is that dest[] and src[] must */
/* be so many chars apart for this to work. */
void slowkillcrlf(dest,src,nlines,nbytes,splits)
char far *dest; char far *src;
int *nlines,*nbytes,*splits;
{
extern int intexttype;
register int x,nbyte;
int nline;
register int lc;
register char far *s;
register char far *d;
extern int MAXLN;

    d=dest; s=src;
    lc=MAXLN-1; nbyte=nbytes[0];
    s[nbyte]=26; /* 26 chosen because it's not equal to 13, 10, 0, 255 */
    nline=0;
    while(nbyte-- > 0){
      x=(s[0]);
      /* Read MSDOS, MAC, UNIX files by default */
sk1:
      if(x==13){
        x=s[1];           /* works because s[nbyte]==26 */
        if(x==0 || x==10) {++s; --nbyte;}
        goto newline;
      }
sk2:
      if(x==0 || x== 10) {
newline: *d++ = 0; ++s; lc=MAXLN-1; ++nline; continue;
      }
sk3:
      if(!lc) {
splitline:  *d++ = 0; ++nline; *d++ = 2; lc=MAXLN-1-1; splits[0] += 1;
      }
sk4:
      *d++ = *s++; --lc;
    }
    nbytes[0]=((int)(d-dest)); nlines[0]=nline;
}
#endif

