#include "v.h"

/* gcc required for unix operating system */
/* TURBO-C 1.5 or 2.0 required for MSDOS operating system. */
/* This is used to reduce overhead. Might use sprintf() instead */
/* for any unix system, because generally that will not change */
/* the total overhead for the editor executable. */

#ifdef ssprintf
/* DO NOTHING */
#else
#include <stdarg.h>

int  ssprintf(char *s,char *format, ...)
{
    va_list argptr;

    va_start(argptr, format);     /* initialize argument pointer */
    _svprinter(s,format, argptr);    /* do it */
    va_end(argptr);
}

_svprinter(s,format,argptr) char *s; char *format; va_list  argptr;
{
int  c;
char  buf[64];
char  cbuf[2];
char *p;
extern char *lltoa();

    cbuf[1]=s[0]=0;
    while((c= *format++) !=0)    /* main loop to scan format string */
    {
        if(c=='%') goto arg_eval; /* scan format spec */
maincharcopy:
        cbuf[0]=c; p=cbuf;
arg_eval_ret: strcat(s,p);
    }
    return;

arg_eval:
    c= *format++;        /* Get next char */
    p="";
    switch(c)
    {
        case 'd':
        case 'u':                           /* unsigned */
            lltoa((LLONG) va_arg(argptr, int), p=buf);
            break;
#if LLONGislong
        case 'l':                           /* long */
            if((c=format[0])=='d'  || c== 'u') ++format;
            else goto quitit;
            lltoa((LLONG) va_arg(argptr, LLONG), p=buf);
            break;
#endif
        case 's':
            p=(char *)(va_arg(argptr, char *));
            break;
        case 'c':                               /* character */
            c=va_arg(argptr, int);
        case '%':
             goto maincharcopy;
quitit:
        default:             /* invalid type - return for literal output */
            --format; c='%'; goto maincharcopy;
    }
  goto arg_eval_ret;

}    /* end of _svprinter */

#define TESTSSPRINTF 0
#if TESTSSPRINTF
/* #define LLONG long */
char *lltoa(n,str) LLONG n; char *str;
{
LLONG i;
char *p;
char q[61];
char flag;
  i = n; *(p = &q[60]) = '\0'; flag=(n<0);
  if(flag) i = -i;
  do { *--p = '0' + i%10; } while( (i /= 10) > 0);
  if(flag) *--p = '-';
  strcpy(str,p);
  return str;
}

strcat(s,t) char *s; char *t; {
  s += strlen(s);
  while((*s++ = *t++)!=0);
}


#include <stdio.h>
main(){
char s[128];
 ssprintf(s,"%s %u\n","Test",100);
 puts(s);
 ssprintf(s,"%s %u\nOne more line\n","Test",100);
 puts(s);
 ssprintf(s,"%s %u\nTwo more lines\nAns=%d\n","Test",100,201);
 puts(s);
}
#endif
#endif

#if MATHFLOAT
int mathinteger=0;         /* 0=double, 1=decimal */
setmathformat(){
  getquery("Math format (printf):");
  if(sysv[0]){
    freeup(MATHFMT);
    safecore(&MATHFMT,sysv);
  }
  return getnumquery("Double (0) or integer (1) data?",&mathinteger,0,1);
}

#if 1
convert2double(dest) char *dest; {
/* Replace dest by its float computation */
char buf[512]; /* Has to be at least 310 chars + number of digits */
register char *p;
char *sob(); double atof(); double x,y;
int i;
char *skipdecimal();
extern char *MATHFMT;       /* Usually, its "%.08g" */
extern int mathinteger;

   x=atof(p=sob(dest));
   while(p[0]){
     if((p[0]=='-' || p[0]=='+') &&
        (isdigit(p[1]) || p[1]=='.')) ++p;
     p=sob(skipdecimal(p));
     y=atof(p+1);
     switch(p[0]){
     case '+': x += y; goto addone;
     case '-': x -= y; goto addone;
     case '/': x /= y; goto addone;
     case '*': x *= y;
     addone:   p=sob(p+1); break;
     case '=': if(p[1]=='='){
                 y=atof(sob(p+2));
                 if(x == y) x=1; else x=0;
               }
     default: goto quit;
     }
   }
quit: ;
   i=x;
   if(mathinteger)
   sprintf(buf,MATHFMT,i); else sprintf(buf,MATHFMT,x);
   strnzcpy(dest,buf,MAXLN-1);
   return 0;
}

char *skipdecimal(s) char *s;{
extern char *skipdigits(),*sob(),*strchr();
register char *p;
 p=sob(s);
 if(p[0]=='.') ++p; else {p=skipdigits(p); if(p[0]=='.') ++p;}
 p=skipdigits(p);
 if(strchr("eEdD",p[0])!=(char *)0) ++p; else return p;
 if(p[0]=='-' || p[0]=='+') ++p;
 return skipdigits(p);
}

char *skipdigits(p) register char *p; {
while(isdigit(p[0])!=0) ++p;
return p;
}
#endif

#if !CALCULATOR
void calculator(){ banner("No calculator!"); getbyte();}
#else
#include "vee.c" /* Mark Morley's expression evaluator 1992 */
calculator(dest) char *dest; {
/* Replace dest by its float computation x */
double x;       /* Float computation answer */
int i;
char buf[512];  /* Has to be at least 310 chars + number of digits */
extern char *MATHFMT;       /* Usually, its "%.08g" */
extern int MAXLN,mathinteger;
LONG ccBIOS();

/* Using vee.c function to do the dirty work */
/* evalexpr(src,errmsg,ans)  char *src,*errmsg; double *ans; */
/* Returns 0==OK, 1==No ans to print, 2==Error /w error msg */
 if((i=evalexpr(dest,buf,&x))==2){
   banner(buf); while(ccBIOS(0)!=13) bell(); /* Get a char for sure */
 }
 if(i==1) dest[0]=0;
 if(i==0){
   i=x;
   if(mathinteger)
   sprintf(buf,MATHFMT,i); else sprintf(buf,MATHFMT,x);
   strnzcpy(dest,buf,MAXLN-1);
 }
 return 0;
}
#endif

#endif
