/*
 * V4.C
 */

#include "v.h"

void hiloPACK(){
LONG amt;
  if((amt = (ebuf-hbuf)) != (LONG)0) moveMEM(lbuf+1,hbuf,amt);
  *(lbuf += amt) = *(hbuf = ebuf) = EOS;
}

int HIBLtoLOW(){
int n,I,N;
  if((N=getmeminfoindex(curfile,finfo[curfile].nbLOW))== -1) return -1;
  n=meminfo[N].numbytes;
  if(lbuf+n>=ebuf) return -2;
  CPfromBLOCK(I=meminfo[N].record,lbuf+1,n);
  lbuf += n;
  rlBLOCK(I);
  --(finfo[curfile].nbTOT);
  killinfo(N);
  return 0;
}

/*
 * HITOLO
 *
 * Purpose:
 *              Merge high buffer onto low buffer and reset
 *              lbuf and hbuf pointers.
 * Returns:
 *              Nothing.
 * Notes:
 *              o Normal use calls PackScreenBuffer() first.
 *              o The block move must be able to copy null bytes.
 *              o lbuf points to the null byte delimiter at the
 *                end of the last string in the lower buffer.
 *              o The buffer is empty if lbuf = bufbase - 1.
 *              o Always, bufbase[-1] = EOS, bufbase[-2] = 0xFF.
 *              o For the ext memory model, there is much more to do.
 *                The basic idea is to pack down the buffer to the
 *                low end, copy in a block from above, and then
 *                purge the low buffer to a block. This is repeated
 *                until all high blocks have been copied. Note:
 *                this works only because the main buffer GAP is
 *                big enough to accept a copy of a whole block (2k).
 *              o The strange code at the end is used to insure that
 *                the GAP does not collapse. The blank line purge is
 *                required after the main while() in order to keep
 *                from adding extraneous lines on the end of the file.
 */
VOIDS HiToLowBlockMove(k) int k; {
int n;
  hiloPACK();
  if(k){
    while(1){
      n = putLOWblock();
      if(n == -1) break;
      if(n == -2) goto slow;
    }
    finfo[curfile].nbLOW = finfo[curfile].nbTOT;
    goto purge;
  }
slow:
  while(1){
    if(HIBLtoLOW()) break;
    if(bufbase+SIZEBLOCK <= lbuf) putLOWblock();
  }
purge:
  while(loPull(sysx)){
    if(sysx[0]){loPush(sysx); break;}
  }
  if(HEADROOM >= hbuf-lbuf) if(putLOWblock()) noroom();
}

void lohiPACK(){
LONG amt;
  if((amt = (lbuf+1)-bufbase) != 0) moveMEM(hbuf = hbuf - amt,bufbase,amt);
  *ebuf = *(lbuf = bufbase-1) = EOS;
}

/*
 * LOWTOH
 *
 * Purpose:
 *              Moves low-packed buffer to high buffer end.
 * Notes:
 *              o Call PackScreenBuffer() before using so
 *                that the screen buffer is merged onto the
 *                low end prior to the move.
 */
void LowToHighBlockMove(k) int k; {
int n; struct fileinfo *p;
  p= &finfo[curfile];
  if(p->nbLOW>=p->nbTOT){
    hiloPACK();
    while(loPull(sysx)){
      if(sysx[0]){loPush(sysx); break;}
    }
  }
  lohiPACK();
  if(k){
    while(1){
      n = putHIblock();
      if(n == -1) break;
      if(n == -2) goto slow;
    }
    p->nbLOW = 0;
    return;
  }
slow:
  while(1){
    if(LOBLtoHI()) break;
    if(ebuf-hbuf >= SIZEBLOCK) putHIblock();
  }
  if(HEADROOM >= hbuf-lbuf) if(putHIblock()) noroom();
}

LOBLtoHI(){
int n,I,k;
struct fileinfo *p;
  p= &finfo[curfile];
  if((n=p->nbLOW)==0) return -1;
  k=getmeminfoindex(curfile,n-1);
  n=meminfo[k].numbytes;
  if(bufbase+n>hbuf) return -2;
  CPfromBLOCK(I=meminfo[k].record,hbuf-n,n);
  hbuf -= n;
  rlBLOCK(I);
  --(p->nbLOW);
  --(p->nbTOT);
  killinfo(k);
  return 0;
}

/*
 * STARTUP
 *
 * Purpose:
 *              Move in lines to the screen buffer
 *              and do an initial start on the editor.
 */
VOIDS startup() {
extern char *cd;
  UnPackScreenBuffer(0);
  curoff = col = row = 0;
  statblank=TRUE;
  lncount=1;
  dirsplit(sysfile,cd);
  drawall();
}

/*
 * TOPFIL
 *
 * Purpose:
 *              pack the buffer, go to top of file,
 *              refresh screen with cursor home.
 * Notes:

 *              o Fails if the screen cannot be packed on the low end.
 */
VOIDS topfile() {
int PackScreenBuffer();
  if(PackScreenBuffer(0)) {noroom(); return;}
  LowToHighBlockMove(1);
  startup();
}

/*
 * EOFILE
 *
 * Purpose:
 *              Cursor home on last line of file.
 * Notes:
 *              Fails if the buffer cannot be packed to low end.
 */
void eofile() {
int i,j,N;
char *p;

  if(PackScreenBuffer(ROWMAX+1)){noroom(); return;}
  HiToLowBlockMove(1);
  j=lncount=0;
  while((i=getmeminfoindex(curfile,j)) != -1){
    lncount += meminfo[i].numlines; ++j;
  }
  for(p=bufbase;p<=lbuf;p += 1+strlen(p)) ++lncount;
  if(lncount == 0) lncount = 1;
  col = 0;
  row = middle((LLONG)0); /* (lncount > ROWMAX) ? ROWMAX : lncount-1; */
  UnPackScreenBuffer(row+1);
  drawall();
}

/*
 * MASSDE
 *
 * Purpose:
 *              Delete many lines. Deleted lines are copied
 *              to the push buffer, if possible.
 * Returns:
 *              FALSE - Failure to copy all lines to push buffer.
 *              TRUE  - It worked as planned.
 * Notes:
 *              o A positive lx causes deleted lines to be added
 *                onto the end of the push buffer.
 *              o A negative lx causes the old push buffer to
 *                be over-written with the new deleted lines.
 *              o pushlines() now returns the number of lines
 *                actually moved.
 */
int massdelete(n,lx)
int n;  /* n==1 for delete and append notepad, n==0 for delete only */
LLONG lx;
{
int i;
int j;
int k;
LLONG kk;
extern LLONG pushlines();
int hiPull();
struct bigarray X;

  kk=((lx>=0) ? lx : -lx);
  if(kk==0 || (n && !curfile)) return FALSE;
  i=(kk==1);
  if(i) strcpy(sysvv,line[row]);
  X.str=(i ? sysvv : 0);
  if(n && (kk = pushlines(0,0,(struct bigarray far *)&X,lx)) == 0)
    return FALSE;
  j = (ROWMAX+1) - row; /* at most j screen lines to delete */
  if(kk>j) {
    while(kk>j && hiPull(sysv)) --kk;
  } else j = (int)kk;
  if(j){
    PUSHnodisp();
    curses();
    if(!HASDELETELINE && !HASSCROLL) nodisp=TRUE;
    for(i=0;i<j-1;++i) delln(sysvv);
    POPnodisp();
    delln(sysvv);
  }
  return TRUE;
}

#if MSDOS
maketempfilename(s) char *s; {
unsigned x; FILEP fp;
char *p,*q; char *ffname(),*strchr();
  p=ffname(s);
  if((q=strchr(p,'.'))!=(char *)0) q[0]='#';
  strcat(p,"########");
  p += 7;
  for(x=0;x<(unsigned)0xFFFF;++x){
   char2asciiBASE((unsigned char)(x / 256),p  ,16,0);
   char2asciiBASE((unsigned char)(255 & x),p+3,16,0);
   p[2]=p[1]; p[1]='.';
   if((fp=fopenbread(s))==(FILEP)0) break;
   closedfile(fp);
  }
  return 0;
}
#endif

#if SUN350 || DEC3100 || IBMAIX /* sun 3/50, sun 386/i, BSD4.x*/
maketempfilename(s) char *s; {
unsigned x; FILEP fp;
char *p,*q; char *ffname(),*endof();
  p=ffname(s);
  if(p[0]=='.') p[0]='#';               /* Don't want invisible files */
  if(strlen(s)>MAXFNAME-10) s[MAXFNAME-10]=0;
  strcat(p,".");
  p = endof(s);
  for(x=0;x<(unsigned)0xFFFF;++x){
   char2asciiBASE((unsigned char)(x / 256),p  ,16,0);
   char2asciiBASE((unsigned char)(255 & x),p+2,16,0);
   if((fp=fopenbread(s))==(FILEP)0) break;
   closedfile(fp);
  }
  return 0;
}
#endif


/*
 * CLOSEF
 *
 * Purpose:
 *              Dump buffer to disk.
 * Notes:
 *              o Uses the screen buffer as a disk buffer.
 *              o Requires screen buffer to be packed on high end.
 *              o Blank lines can be written to the output file,
 *                provided all text is above the current cursor
 *                position. Otherwise, blank lines are stripped
 *                from the end of the file.
 */

#if MSDOS
/* does not use return value of x=2. Child fork not implemented. */
int closef(filename) char *filename; {
char *strchr(),*endof(),*ffname();
char *p;
FILEP fp;
char tmpname[MAXFNAME];
char bakname[MAXFNAME];
int flag,backflag;

  killstatus();
  flag = FALSE;
  if(filename[0]==EOS ||
     strcmp(filename,NOTEPAD)==0 ||
     strcmp(filename,UNTITLED)==0) {
    bell();
    if(!getfname("Enter output file name: ",tmpname) || exists(tmpname)){
      lcount(); return FALSE;
    }
    strcpy(filename,tmpname);
  }
  if(!PackScreenBuffer(row)) {
    killstatus();
    strcpy(tmpname,filename);
#if MSDOS
    backflag=(BACKUPS && (classify(filename)!=2));
    if(backflag){
      strcpy(bakname,tmpname);
      maketempfilename(tmpname);
    }
#endif
    fp = fopenbwrite(tmpname);          /* WMODE */
    bbanner("Saving: ",filename);
    if(fp != (FILEP)0) {
      flag=FILEtoDISK(fp);
    } else flag=0;
    if(flag==0) bellpressany("File not saved");
#if MSDOS
    else if(backflag){
      extern char *ffname();
      maketempfilename(bakname);
      rename(filename,bakname); /* Could fail for new file */
      rename(tmpname,filename); /* Probably never fails */
      /* Move bakname to backup directory */
      if(BACKUPS){
        getbackupfname(tmpname); /* $HOME\PIbackups or .\PIbackups */
        mkdir(tmpname);          /* Usually this does nothing */
        addslash(tmpname);
        strcat(tmpname,ffname(filename));
        maketempfilename(tmpname);      /* New name in subdirectory */
        rename(bakname,tmpname);        /* Move old file to directory */
        /* All of these can fail, no space, CD rom, protection error */
      }
    }
#endif
    /* Restore main buffer */
    UnPackScreenBuffer(row);
  }
  lcount();
  return flag;
}
#endif

#if SUN350 || ARDENT || DEC3100 || IBMAIX /* sun 3/50, sun 386/i, BSD4.x*/
/* Returns x=2 if file being edited is .mm.... from MM mail program */
/* In this case, we assume PI being run under MM, so should not suspend */
/* editor because it is a child process. Probably a better way, but this */
/* indeed works most of the time. */
#include <sys/types.h>
#include <sys/stat.h>

int closef(filename) char *filename; {
extern char *strchr(),*strrchr(),*endof(),*strstr();
FILEP fp;
char *p;
char tmpname[MAXFNAME];
STATIC int flag;
char tempname[MAXFNAME];
char bakname[MAXFNAME];
struct stat statbuf;
STATIC int temp;
int fail,child;
extern char *getenv(), *ffname();

temp = 0;

top:
  killstatus();
  if(filename[0]==EOS ||
     strcmp(filename,NOTEPAD)==0 ||
     strcmp(filename,UNTITLED)==0) {
    bell();
    if(!getfname("Enter output file name: ",tmpname) || exists(tmpname)){
      lcount(); return FALSE;
    }
    strcpy(filename,tmpname);
  }
  if(strstr(filename,".mm-outgoing")!=(char *)0) child=1; else child=0;
  statbuf.st_mode= 0; stat(filename,&statbuf);
  killstatus();
  /* Build a TEMP file name for saving the file */
  strcpy(tmpname,(temp==1 ? "/tmp/" : filename));
  strcpy(ffname(tmpname),"piXXXXXX");
  mktemp(tmpname);
  fp = fopenbwrite(tmpname);  /* WMODE */
  if(fp == (FILEP)0) {   /* bad open */
  /* Bad file name, no inode, file name on CD or no permission. */
     strcpy(bakname,"Can't open to write: "); strcat(bakname,tmpname);
      bellpressany(bakname);
      strcpy(filename,UNTITLED);
      goto top;
  }
  flag = 0;
  if(!PackScreenBuffer(row)) {
    bbanner("Saving: ",filename);
    flag=FILEtoDISK(fp);
    UnPackScreenBuffer(row);  /* Restore main buffer */
  }
  if(flag==0) bellpressany("File not saved");
  /* If no disk space, then try /tmp */
  if(flag == 0 && temp == 0) { temp = 1; unlink(tmpname); goto top;}
  if(flag == 0 || temp != 0) {
    cleardisplay();
    ePrint("Out of disk space:"); crlf(); bell();
    ePrint("The editor image has been partially saved in ");
    ePrint(tmpname); crlf();
    ePrint("Disk file "); ePrint(filename); ePrint(" is unchanged.");
    crlf();
    goto quit;
  }
  /* Construct backup file name */
  strcpy(tempname,filename);
  strcpy(ffname(tempname),"piXXXXXX");
  mktemp(tempname);
  fail = (classify(filename)==1 ? rename(filename,tempname) : 0);
  if(fail != 0 || rename(tmpname,filename) != 0) {
    cleardisplay();
    if(fail){
      ePrint("Original file "); ePrint(filename); crlf();
      ePrint("Could not be renamed to "); ePrint(tempname); crlf();
    }
    ePrint("The file was saved as: "); ePrint(tmpname); crlf();
    ePrint("Disk file "); ePrint(filename); ePrint(" is unchanged."); crlf();
    goto quit;
  }
  /* Put identical file modes onto saved file */
  if(statbuf.st_mode != 0) chmod(filename,(statbuf.st_mode));
  /* try to put backup file away into directory ./PIbackups */
  /* If it does not exist or option is off, then .. Nov 1998 */
  /* try to put backup file away into directory $HOME/PIbackups */
  if(BACKUPS){
    if(BACKUPS==2){
      extern char *cwd();
      p=cwd(); /* Get the current working directory */
      if(p == (char *)0) p=".";
      strcpy(bakname,p); addslash(bakname);
      strcat(bakname,PIBACKUPS);
      mkdir(bakname,0777);               /* create backup dir */
      chmod(bakname,0777);
      if(classify(bakname)!=1) p=getenv("HOME"); /* Use $HOME otherwise */
    } else p=getenv("HOME");
    strcpy(bakname,(p == (char *)0)? "." : p);
#if !ARDENT /* Do a better bookkeeping job for BSD long filenames */
    addslash(bakname);
    strcat(bakname,PIBACKUPS); addslash(bakname);
    strcat(bakname,(char *)ffname(filename));
    maketempfilename(bakname);
#else
    addslash(bakname);
    strcat(bakname,PIBACKUPS);
    strcat(bakname,"/PIXXXXXX");
    mktemp(bakname);
#endif
    fail = (classify(tempname)==1 ? rename(tempname,bakname) : 0);
    if(fail!=0){
      strcpy(tmpname,bakname); p=strrchr(tmpname,'/');
      if(p != (char *)0) p[0]=0;
      mkdir(tmpname,0777);               /* create backup dir */
      chmod(tmpname,0777);
      fail = (classify(tempname)==1 ? rename(tempname,bakname) : 0); /* try again */
    }
    if(fail){
      cleardisplay();
      ePrint("Original file is now "); ePrint(tempname); crlf();
      ePrint("Not renamed to "); ePrint(bakname); crlf();
      goto quit;
    }
  } else {
    /* erase backup file, because user doesn't want any clutter */
    unlink(tempname);
  }
  lcount();
  return ((child!=0 && flag==1) ? 2: flag);
quit:
    pressany("");
    drawall();
    return -1;
}

#endif

exists(filename)
char *filename;
{
int getupper();
  if(classify(filename)==1){
      bbanner(filename," exists, Overwrite? "); bell();
      if(getupper() != 'Y') { lcount(); filename[0] = EOS; return 1;}
  }
  return 0;
}

/* Is it a disk file, a new file or a tty? */
classify(filename)
char *filename;
{
int flag; FILEP fp;
  flag=0;
  if((fp = fopenbread(filename)) != (FILEP)0) {
    if(!isatty(fileno(fp))) flag=1; else flag=2;
    closedfile(fp);
  }
  return flag;  /* 0=new file, 1=already exists, 2=tty */
}

/*
 * FILEtoDISK
 *
 * Writes the currently edited file to disk. Assumes the screen buffer
 * has been pushed onto the low and high buffers. Returns 0 on failure,
 * otherwise nonzero.
 */
FILEtoDISK(fp)
FILEP fp;       /* open file pointer */
{
int nbl;        /* number of low buffer blocks in use */
int i,j,flag,k; int I;
char far *q;
  nbl=finfo[curfile].nbLOW;
  flag=unload((FILEP)0,(char *)0,(char *)0);        /* initialize */
  j=0;
  while(1){                                    /* write low blocks first */
    if(j==nbl){                                /* and then */
      unload(fp,bufbase,lbuf);                 /* write low buffer */
      flag=unload(fp,hbuf,ebuf-1);             /* write high buffer */
    }                                          /* then high blocks */
    i=getmeminfoindex(curfile,j);
    if(i == -1) break;
    ++j;
#if MSDOS
    CPfromBLOCK(meminfo[i].record,lbuf+1,k=meminfo[i].numbytes);
    if((flag=unload(fp,lbuf+1,lbuf+k)) == 0) break;
#else
    q=getmemblock(meminfo[i].record);
    k=meminfo[i].numbytes;
    if((flag=unload(fp,q,q+k-1)) == 0) break;
#endif
  }
  flag=unload(fp,(char *)0,(char *)0);        /* flush buffer, fclose(fp) */
  return flag;
}

/*
 * UNLOAD
 *
 * Purpose:
 *              Unload a buffer to an open disk file, using the
 *              screen buffer as a temporary disk buffer. Close
 *              the output file on exit if lo==0. Initialize
 *              i=0,flag=TRUE if fp==0.
 * Returns:
 *              TRUE  -  Operation worked
 *              FALSE -  Operation failed.
 * Notes:
 *              o A screen buffer of SIZEBLOCK + MAXLN + 1 characters
 *                is required.
 */
int unload(fp,lo,hi)
FILEP fp;
char *lo,*hi;
{
register char *p;
register int f;
static int i;   /* i must be saved between calls! */
static int flag;/* flag must be saved between calls */
static int ff,flg; /* ditto for these */
extern int strlen(),ewrite();
char *endof();

#define WSIZE SIZEBLOCK              /* SIZEBLOCK+1+MAXLN < screen size */

  if(fp==0){
    i=0;
    flg = (outtexttype==CRLFtexttype) ? 1 : 0;
    ff = (outtexttype==CRtexttype) ? 13 : 10;
    /* Obsolete static var 1995 */
    /*  flgi = (intexttype == CRLFtexttype) ? 1 : 0; */
    return (flag = TRUE);
  }
  if(lo==0){
    if(i && flag) {
      if(ewrite(fileno(fp),(char far *)scrbuf,i)<i) flag = FALSE;
    }
    if(closedfile(fp)) flag=FALSE;
    return flag;
  }
  if(flag==FALSE) return FALSE;

  p=lo;
  while(p<=hi){
    f=strmov(scrbuf+i,p);       /* strmov copy to null, ret count */
    i += f; p += f+1;
    if(flg) scrbuf[i++]=13;
    scrbuf[i++] = ff;
    if(i>=WSIZE) {
      if(ewrite(fileno(fp),(char far *)scrbuf,i)<i) {
        flag = FALSE; break;
      }
      i=0;
    }
  }
  return flag;
}
