/*
 * V5.C
 *
 */

#define KEYDEFS 1               /* include key defs from v.h            */
#include "v.h"

void CenterRefresh(){
  if(row==ROWMAX) Crefreshh((LLONG)0);     /* refresh, cursor center */
}

/*
 * EDITLN
 *
 * Purpose:
 *              Add or delete a character from a line
 *
 *              o Clumsy (but accurate) routines are used to refresh
 *                the screen. Cleaner I/O is possible with more
 *                capable terminals.
 *              o Insert mode is primitive.
 *              o Character delete is primitive.
 */
void editln(c)
int c;
{
char *p;
int i;
int j,k,off,n;
char r[2];
int mydisp;
extern int margin,nodisp;
int strlen();
char *sob(),*toprint();
unsigned char *curchar();
extern void join();

  r[0] = ' '; r[1] = '\0';
  PUSHnodisp();
  p = line[row];
  switch(c) {
  case   8:     /* Delete char left */
  case 127: if(col == 0 && curoff==0) {
              (insmode ? join() : bell());
              return;
            }
            if(insmode || (curoff>0)) {edleft(); curses();}
            /* and fall through to case 0 */
            else { /* col>0 && insmode==0 && curoff==0 */
              --col; if(*curchar()) { *curchar()=' '; erachar();}
              goto done;
            }
  case   0:       /* delete char right */
            if(*(p=(char *)curchar())!=0) {
              strcpy(p,p+1);
              eraseol();
              xPrint(p,row,col);
            }
            goto done;
  };
  c &= 255;                     /* strip to 8 bits */
  if(c==0) c=128;               /* can't put NULL into strings */
  if(insmode){
    if(WRDWRP==0 && curoff+col>=MAXLN-1){
      bell(); eddn(); homeit(); curses(); lineinsert();
    }
    if(strlen(line[row]) >= MAXLN-1){bell(); goto done;}
      /* tried to extend line too far */
      /* WRDWRP margin is at most MAXLN-2 */
  }
  i = strlen(p=line[row]);
  if(col>=COLMAX){ edright(); edleft(); }
  off=min(col+curoff,MAXLN-1);
  while(i<off) p[i++] = ' ';     /* add blanks */
  if(i<=off) p[off+1] = EOS;
  if(insmode && i>off) moveMEM(p+off+1,p+off,(LONG)(i-off+1));
  r[0] = p[off] = c;            /* add char to line, or writeover */
  xPrint(r,row,col);
  if(col<COLMAX) {
    ++col; ++off;
    if(insmode && i>=off) { xPrint(p+off,row,col); }
  } else bell();
  if(margin==0) goto done;
  if(WRDWRP) {
    if(strlen(p=line[row])>margin && *sob(&p[margin]) != 0){
      for(k=col,j=curoff+col,i=max(j-1,margin);i>=0;--i) {
        if(p[i] == ' ' && p[i+1] != ' ' && i<=margin) {
          n=0; off=i+1;
          if(testindent()) { /* add blanks at front? */
            while(p[n] == ' ') sysx[n++] = ' ';
          }
          strcpy(&sysx[n],&p[off]); p[off]=0;  /* split line here */
          if(off < curoff+COLMAX){
            putcursor(row,max(off-curoff,0)); eraseol();
          }
          eddn(); curses(); addln(sysx,TRUE);
          if(j<off) {col=k; edup();}
          else curfix(1+n+(j-off),0);           /* get col right */
          break;
        }
      }
    }
    CenterRefresh();    /* refresh, cursor center */
  }
done:
curses();
POPnodisp();
}

static char old[40]={0};
void lnumcount() {
int i;
char v[40];
char *endof();

  if(!nodisp){
    if(DOSTATUS==1){
#if LLONGislong
#define STATUSFMT "Line %ld [%u,%u]     "
#else
#define STATUSFMT "Line %u [%u,%u]     "
#endif
      ssprintf(v,STATUSFMT,(LLONG)lncount,row+1,curoff+col+1);
      i=0; if(!statblank) while(v[i] && v[i]==old[i]) ++i;
      if(i<strlen(v)) {      /* Save it */
        strcpy(old,v);
        xPrint(&v[i],-1,max(0,COLMAX-20+i));
      }
    }
  }
}

void recordbanner(){
char *p; char d[128];
  if(!record){record=1; banner("Recording Started ");}
  strinvvideo("Stop memorize ");
  identifykey(RUNMEMORIZE,d);
  strinvvideo(d);
  eraseol();
  lnumcount();
}

/*
 * LCOUNT
 *
 * Purpose:
 *              Display line count and free space on the STATUS line.
 * Notes:
 *              o A bell should be added for less than 1k remaining.
 */
void lcount() {
char v[256];
int j;
int width;
char *endof();
extern int macrun,repeats,savcount;

  if(macrun || savcount || repeats>1) goto docurses;
  if(!nodisp) {
#if BSDunix || SYS5
    {extern int syscolor;
      if(syscolor!=1) setcolorsUNIX(1);
    }
#endif
    if(testkey()||(macrun != 0 && (macrep > 1 || macind < macmax-1)))
      goto docurses;
    if(DOSTATUS) {
      if(DOSTATUS==3){
        if(makeasciistatus()) goto docurses;
        statblank=TRUE;
      }
      if(statblank) {
        putcursor(-1,0);
        ssprintf(v,"File %u",curfile);
        strinvvideo(v);
        ePrint(": ");
        if(record) recordbanner();
        else
        if(drawline) strinvvideo(LINEDRAWMODE);
        else
        if((width=COLMAX-9-20)> 0) {
          /* COLMAX-9-20 = num chars left for file name, etc */
          strcpy(v,sysfile);
#if MSDOS
          strcat(v,HELPSTR);
/*          if(strcmp(sysfile,UNTITLED)==0) strcat(v,HELPSTR); */
#else
          if(strcmp(sysfile,UNTITLED)==0){
            if(KEYMODE==1) strcat(v," (Emacs)");
            if(KEYMODE==2) strcat(v," (WDstar)");
            if(KEYMODE==3) strcat(v," (WDperf)");
          }
          strcat(v,HELPSTR);
/*          if(KEYMODE<1 || KEYMODE >3) strcat(v,HELPSTR); */
#endif
          if(!insmode) strcat(v,INSERTMODE);
          j=strlen(v);
          if(j<width) j=0;
          else {
            j -= width; moveMEM(v+j,".. ",3);
          }
          ePrint(v+j);
          eraseol();
        }
      }
      lnumcount();
      statblank = FALSE;
    }
docurses:
    curses();
  }
}

void char2asciiBASE(x,s,base,terminator)
unsigned char  x; int base; char *s; char terminator; {
int y,big;
/* x = x0*base + x1*base^2 + x2*base ^3 + ... + xn*base^n */
/* For character data, x <= 256, so we can find base^n cheaply */
     switch(base){
     case 2: big= /*  2^7 */ 128; break;
     case 8: big= /*  8^2 */  64; break;
     case 16:big= /* 16^1 */  16; break;
     case 10:
     default:big= /* 10^2 */ 100;
     /* strip leading zeros on base 10 */
     while((x / big) == 0 && big!=1)  big /= base;
     break;
     }
/* Convert to ascii string */
     while(big){
        y = x/big; x %= big;  big /= base;
        *s++ = y + (y>=10 ? ('A'-10) : '0');
     }
     *s=terminator;
}


int makeasciistatus() {
char s[60];
unsigned char x;
extern unsigned char *curchar();
  if((x= *curchar())!=0){
    strcpy(s,"Char=' ' Oct=777 Hex=FF Bin=11111111 Dec=    ");
    s[6]=x;
    char2asciiBASE(x,s+13, 8,' ');
    char2asciiBASE(x,s+21,16,' ');
    char2asciiBASE(x,s+28, 2,' ');
    char2asciiBASE(x,s+41,10,' ');
    banner(s);
    return 1;
  }
  return 0;
}

/*
 * PUSHLI
 *
 * Purpose:
 *              Push lines from main buffer to push/pop buffer.
 *              The number of lines to push is held in lx.
 *              with the first line at the cursor position.
 * Returns:
 *              0       Failure
 *              n       n lines processed to push buffer
 * Idea:
 * Appends to the NotePad are allowed. Other operations are illegal.
 * Appends do not affect the cursor in the NotePad.
 *
 * The basic algorithm:
 *
 *   a. If lx<0 or the argument was '0', then scrap the NotePad.
 *   b. If lx<0, then let lx = -lx.
 *   c. If lx==0, then return 0.
 *   d. Turn off the display: nodisp=1.
 *   e. Call newedit() to edit the kill ring. This puts the
 *      current file out to external blocks. If it fails, then
 *      call noroom() and return 0.
 *   f. Do HiToLowBlockMove(). This positions the NotePad to
 *      the end. There is nothing to do if the NotePad is already
 *      at the end of file.
 *   g. Repeatedly, copy a high block from the entry file, then
 *      loPush lines until lx lines have been processed. The
 *      screen buffer is used to copy the blocks. All loPush()
 *      operations apply to the NotePad.
 *   h. Set new values for row, col, lncount for the NotePad.
 *   i. Do newedit() on the entry file. UnPackScreenBuffer(row).
 *      Turn the display back on.
 *   j. Return sysarg if there is no error, otherwise do noroom()
 *      and return the number j of lines actually processed.
 */
char RECMARK[2]={'\1',0};
/* buff[0].str==(char *)0 implies use file buffer. */
/* Otherwise, buff[] is an array of pointers of size sysarg. */
LLONG pushlines(START,COLUMNS,buff,lx)
int START,COLUMNS; struct bigarray far *buff; LLONG lx; {
int n,i,j,k,kk,r,m,off; extern char *sysx;
struct fileinfo *p;
LLONG jj,rr;

  jj=0;
  PUSHnodisp();
  if((n=curfile)==0 && buff==0) goto quitzero;
  if(lx==0) lx=1;
  if(lx<0){ lx = -lx; scrapfile(0); } /* Strange way to erase notepad */
  nodisp=1;
  /* try to do something simple for non-null array buff[] */
  /* Edit the notepad */
  if(newedit(0)){ noroom(); goto quitzero; }
  HiToLowBlockMove(0);
  if(loPull(sysx)) {
    if(strcmp(sysx,RECMARK)) loPush(sysx);
    if(COLUMNS || lx!=1) loPush(RECMARK);
  }
  if(buff[0].str != 0) { /* Copy buff[jj].str to notepad */
    while(jj<lx){
     fartonearstrcpy(sysx,buff[(int)jj].str);
     if( loPush(sysx) ) ++jj; else break;
    }
  }
  else {
    /* Warning:  info arrays change during the main loop */
    off=finfo[n].nbLOW;                 /* Copy high blocks only */
    while(jj<lx){
      if((r=getmeminfoindex(n,off++)) == -1) break;
      CPfromBLOCK(meminfo[r].record,scrbuf,m=meminfo[r].numbytes);
      i=0;
      while(i<m){
        if(COLUMNS==0){ /* copy lines */
          if(!loPush(scrbuf+i)) {noroom(); goto failed;}
        } else { /* copy matrix */
          strcpy(sysx,scrbuf+i);
          kk=strlen(scrbuf+i);
          if(START>=kk) sysx[0]=0; else strcpy(sysx,scrbuf+i+START);
          kk=strlen(sysx);
          while(kk<COLUMNS) sysx[kk++]=' ';
          sysx[COLUMNS]=0;
          if(!loPush(sysx)) {noroom(); goto failed;}
        }
        if(++jj >= lx) break;
        i += 1+strlen(scrbuf+i);
      }
    }
  }
  loPush(RECMARK);
failed:
  stowaway();
  lbuf=bufbase-1; hbuf=ebuf;
  setfile(n);
  UnPackScreenBuffer(row);
  rr=kk=0;
  while((i=getmeminfoindex(0,kk++)) != -1){
    rr += meminfo[i].numlines;
  }
  if(!rr) rr = 1;
  p = &finfo[0];
  p->linec = rr+1;
  p->colc = 0;
  p->rowc = min((int)rr,ROWMAX/2);
  if(jj) p->dirty=1;
  if(!n) drawall();
quitzero:
  POPnodisp();
  return jj;
}

/*
 * POPLIN
 *
 * Purpose: Pop lines from the notepad buffer onto the screen.
 */
LLONG poplines(POPMETHOD,INSmode,target,maxline,badmatrix)
int POPMETHOD,INSmode,target; int *maxline; int *badmatrix;
{
int n,i,j,r,m,failed,maxlen,offset,off; char *p;
LLONG nlines;
char far *f; int I;

  offset=col+curoff;
  badmatrix[0]=maxlen=failed=n=nlines=0;  /* n=file number of the NotePad */
  off=m=(finfo[n].nbTOT)-1;
  j= -1;
  while(off>=0){
    /* don't need to copy it to search */
    if((r=getmeminfoindex(n,off)) == -1) break;
    f=getmemblock(meminfo[r].record); i= meminfo[r].numbytes;
    if(off == m){++j; --i;}
    while(i>=2){
      if(f[i-1]==0 && f[i-2]==RECMARK[0] && (i==2 || f[i-3]==0)) ++j;
      if(j==target) goto foundit;
      --i;
    }
    --off;
  }
  off=i=0;/* Didn't find the record mark requested */
  if(++j != target) goto end; /* Count first record too (++j) */
foundit:

  if(PackScreenBuffer(row)){failed=1; goto nospace;}
  markblock((!POPMETHOD) ? 0 : offset);
  while(!failed){
    if((r=getmeminfoindex(n,off++)) == -1) break;
    CPfromBLOCK(meminfo[r].record,scrbuf,m=meminfo[r].numbytes);
    ++r;
    while(i<m){
      if(strcmp(p=scrbuf+i,RECMARK)==0) goto done;
      j=strlen(p);
      if(POPMETHOD){                    /* Copy lines? Or matrix? */
        hiPull(sysx);                   /* Copy matrix ... */
        if(j!=maxlen && maxlen && INSmode){badmatrix[0] = -1; break;}
        addstring(p,sysx,FALSE,INSmode);
        p=sysx;
      }
      maxlen=max(maxlen,j);
      if(!loPush(p)) {failed=1; break;}
      i += 1+j;
      ++nlines;
    }
    i=0;
  }
done:
  UnPackScreenBuffer(i=row);
  lncount += nlines;

#if 0   /* Buggy. Lost the screen display. Fixed May 2000 */
  PUSHnodisp();
  nodisp=1;
#endif
  if(nlines) edup();
  curfix(1+offset+maxlen,0); if(maxlen) edleft();
  setcorner();
  while(row<i){ lineup(); incrROW(); }
#if 0
  POPnodisp();
#endif
  drawall();

nospace:
  if(failed) noroom();
end:
  maxline[0]=maxlen;
  return nlines;
}

/*
 * DIVIDE
 *
 * Purpose:
 *              Break a line into two lines at cursor.
 * Notes:
 *              o Fails if addln() fails
 */
int divide() {
char *p;
int i,j;
extern char *sysv;
extern unsigned char *curchar();
  /* divide at front of a line should just insert line! */
  if(!(col+curoff)){addln("",TRUE); return 0;}
  j = 0;
  if(INDENAUTO && insmode) {    /* match indent */
    while(line[row][j] == ' ') sysv[j++] = ' ';
  }
  strcpy(&sysv[j],curchar());
  *curchar()=0; eraseol(); eddn(); curses();
  addln(sysv,TRUE);
  edup();
  return j;
}

int testindent(){
 return (HangingIndent && INDENAUTO && insmode);
}

#if 0           /* debug: memory fragmentation */
                /* Warning: this code assumes no xms */
void defrag_debug()
{
int n,j,k; long v;
  for(j=0;j<maxinfo;++j){
    if(finfo[j].active==0) continue;

    clearscreen();
    fprintf(stderr,"File=%s\n",finfo[j].fname);
    i=startindex(j);
    k=i+finfo[j].nbLOW;
    n=i+finfo[j].nbTOT; v=0;
    fprintf(stderr,(i==k ? "No low blocks\n" : "Low blocks\n"));
    while(i<n){
      if(i==k) fprintf(stderr,"High blocks\n");
      fprintf(stderr,
      "[File=%d] %d. rec=%d, maxsize=%d, bytes=%d, lines=%d\n",j,i,
      meminfo[i].record,SIZEBLOCK,meminfo[i].numbytes,meminfo[i].numlines);
      v += meminfo[i].numbytes;
      ++i;
    }
    if(n==k) fprintf(stderr,"No high blocks\n");
    fprintf(stderr,"Uses %ld bytes, %d blocks\n",v,finfo[j].nbTOT);
    pressany("");
  }
}
#endif
