/*
 * V7.C
 *
 */

#include "v.h"

getfile(filename) char *filename; {
int x;
char tmp[MAXFNAME];
strcpy(tmp,filename);
if(dir(tmp,-1,0,(char *)0,(char **)0) == 1) /* complete file name */
  strcpy(filename,tmp);
  if((x=isinfo(filename)) != 0) {
    bell(); strcat(tmp," already loaded. Load anyway");
    if(!getyesno(tmp)) {sysarg = x-1; return -3;}
  }
  return getafile(filename);
}

void setfinfo(p) struct fileinfo *p; {
  p->rowc=p->colc=p->linec=p->nbLOW=p->nbTOT=p->dirty=p->curoffset=
  p->setmark = p->setmarkcol = p->setmarkline=0;
}

/*
 * KILLFINFO
 *
 * releases memory and junks finfo[] slot.
 */
void killfinfo(p) struct fileinfo *p;{
  setfinfo(p);
  freeup(p->fname);
  p->fname = (char *)0;
  p->active=0;
}

/*
 * SCRAPFILE
 *
 * Junks a file and all its meminfo[] blocks.
 *
 */
void scrapfile(NN) int NN;{
 int i,j,jj; struct fileinfo *p;
  jj=startindex(NN); p = &finfo[NN];
  j=p->nbTOT;
#if 0
  for(i=0;i<j;++i){
    rlBLOCK(meminfo[jj].record);
    killinfo(jj);
  }
#else
  for(i=jj+j-1;i>=jj;--i){
    rlBLOCK(meminfo[i].record);
    killinfo(i);
  }
#endif
  if(NN) killfinfo(p); /* don't kill off finfo[0] */
  else setfinfo(p);
}


int getafile(filename) char *filename; {
FILEP fp;
int start;
int amt;
STATIC
int RDSIZE,OFFSET,i,k,kk,m,mm,eof,N,NN,inbytes,orphans;
int f,flag,kind;
char *p; char far *q;
char t[24];
int eread();
char *strchr(); char *utoa();
extern int blockflag;           /* prompt for block read params */
extern int splitlines;
extern int filekind;
extern char *lltoa();

  if(filename[0] == EOS) return -1;
  mm=splitlines=amt = 0; start = 1;
  if(blockflag){         /* Request for partial read */
    getnumquery("Start block",&start,1,0);
    getnumquery("Count",&amt,0,-1);
  }
#if MSDOS      /* Uppercase file names */
  cvupper(filename);
#endif
  /* Ready to read file from disk. See algorithm above */
  /* 1,2. Get open slot in finfo[] array, open file */
  if((fp = fopenbread(filename)) == (FILEP)0) { /* RMODE */
    return -2;
  }
  if((NN=getslot()) == -1 || !corefinfo(NN,filename)) {
    closedfile(fp); return -1;
  }
  m=startindex(NN);
  /* setup variables f, flag for intexttype */
  flag = (intexttype==CRLFtexttype) ? 1 : 0;
  f = (intexttype==CRtexttype) ? 13 : 10;
  /* 3. Process disk file into GAP */
  sysx[0]=eof=orphans=kind=0;
  OFFSET = 6+2*(SIZEBLOCK/MAXLN); /* max number split lines times 2 */

/* Main READ loop */

  bbanner("    Reading ",filename);
  while(!eof){
      if((N=crBLOCK()) == -1) goto stop;
      q=getmemblock(N);
      RDSIZE=SIZEBLOCK-orphans-OFFSET;
      /* fill input buffer, partial line plus disk read */
      if(orphans>0) segcopy(q,(char far *)sysx,orphans);

      k=eread(fileno(fp),q+orphans,RDSIZE);
      if(k<=0) k=0;
#if 0
      home(); ePrint(lltoa((LLONG)(mm+1),t));
#endif

      if(k<RDSIZE) eof=1;
      inbytes = orphans + k;
      if(eof) { /* buffer contains remaining bytes */
          if(inbytes>0 && (kk=(q[inbytes-1])) != f && kk != 0) {
              if(flag) q[inbytes++] = '\r';
              q[inbytes++] = f;
          }
          orphans=0;
      }
      else {  /* Have added more bytes on top of orphans */
        q[i=inbytes]=orphans=0;
        /* see if we can remove partial line */
        /* Search for 10 or 13. Admit 0 is also end of line. */

        while(--i >= 0){
          if((kk=q[i])==0) {kind |= 8; break;} /* BINARY FILE? */

          if(kk==10){ /* End of line marker? */
            if(i && q[i-1]=='\r') kind |= 1;
            else
            /* Probably a unix file without CR chars */
            kind |= 4;     /* might be a unix file */
            break;
          }

          if(kk==13){  /* Could be part of split cr/lf combo */
            if(orphans){ /* Don't consider it on very end */
              kind |= 2;      /* might be a MAC file */
              break;
            }
          }

          /* kk is an orphan character, but we save it later */
          if(++orphans >= MAXLN-3) { /* no f's or long line */
            if(flag) q[inbytes++] = '\r';
            q[inbytes++] = f;
            q[inbytes++] = 2; orphans=1; /* Put at front of next buffer*/
split:
            ++splitlines;       /* Only do it for long lines */
            break;
          }
        }
        if(orphans) { /* Copy partial line from end to sysx[] buffer */
          segcopy((char far *)sysx,q+inbytes-orphans,orphans);
          inbytes -= orphans;
        }
      }
      /* Skip over some initial blocks if start > 1 */
      if(start>1){--start; inbytes=0;}

      /* log info on file into info[] array */
      if(inbytes>0){

        addinfo(N,0,inbytes,1,m+(mm++)); /* Mark it as unconverted */
        if(amt != 0 && eof == 0 && --amt <= 0) {
           eof=1; bellpressany("Partial Read"); filename[0]=0;
        }
      } else rlBLOCK(N);
  }
stop: /* N == -1 if we got troubles, or ran out of buffer space */
  closedfile(fp);
  finfo[NN].active=1; finfo[NN].nbTOT=mm;
  if(N == -1){
    strcpy(filename,UNTITLED);
    if(!getyesno("No blocks. Proceed"))
      { scrapfile(NN); return -4; }
  }
  if(kind==4) kind=3; if(kind>4) kind=4;
  if(kind && kind != intexttype){
    filekind=kind;
  }
  return NN; /* report file kind found */
}

static char *KindofFile[]={ "MSDOS","MAC","UNIX","BINARY"};
int splitlines=0;
int filekind=0;

void reportfilekind(){
extern int filekind;
 if(filekind){
  char *msg[]={"File might be ","",0};
  msg[1]=KindofFile[filekind-1];
  WarningMessage(msg);
  filekind=0;
 }
}

void reportsplit() {
char tmp[100];
extern int splitlines;
  if(splitlines){
    char *msg[]={"Long lines split","",0};
    /* getnumquery("Long lines split at ^B",&splitlines,0,0); */
    msg[1]=tmp;
    ssprintf(tmp,"Inserted ^B [%u times]",splitlines);
    WarningMessage(msg);
    splitlines=0;
  }
}

/* After reading in a file, the first screen is displayed */
/* and this function begins executing. The call to cvblk() */
/* is inside getmeminfoindex(). */
/* Convert all blocks */
void convertall(NN) int NN; {
int off; LONG ccBIOS();
extern int splitlines;
  off=0; while(getmeminfoindex(NN,off)!= -1){ /* the engine */
           ++off;
           if(!splitlines && ccBIOS(2)) break;
         }
  reportsplit();
}

void cvblk(N)
int N;
{
int x,y; int nlines,nbytes; char far *dest; char far *src;
extern int killcrlf();
extern void slowkillcrlf();
struct bucket far *q;
extern int splitlines;

  q= &meminfo[N]; if(!(q->flag)) return;
  x=q->record;
  dest=getmemblock(x);
  nbytes = q->numbytes;
    /* Another crBLOCK might swap block off to xms memory. */
    memmark[x]=3;  /* Lock the block. Next crBLOCK() leaves x alone. */
    if((y=crBLOCK()) != -1){
      src=dest;
      dest=getmemblock(y);
    }
    else { /* ugh, no memory, must copy over it */
    segcopy(src=dest+SIZEBLOCK-nbytes,dest,nbytes);
    }
    memmark[x]=2; /* Unlock the block */
    slowkillcrlf(dest,src,&nlines,&nbytes,&splitlines);
    if(y != -1){ rlBLOCK(x); q->record = y; }

  q->numbytes = nbytes;
  q->numlines = nlines;
  q->flag=0;           /* Mark as converted */
}

/*
 * INJECT
 *
 * Purpose:
 *              Inject a file into the text buffer at cursor.
 * Returns:
 *              TRUE  - It worked.
 *              FALSE - It failed.
 *
 * To inject a file into the edit buffer:
 *
 *     1. Free the screen buffer for I/O use. Call PackScreenBuffer().
 *        Return -1 on failure.
 *     2. Using putHIblock(), move the upper buffer out to blocks. A partial
 *        block will result for the move of the last of the data. If it fails,
 *        then goto step 5.
 *     3. Read in a file off disk, as outlined above. If it fails, then
 *        goto step 5.
 *     4. Link in the blocks of the file of item 3, to the high blocks of the
 *        current edit. This process always succeeds because it is just
 *        bookkeeping. Note: the total block count is affected, and
 *        the array meminfo[] is updated. Information about the injected file
 *        is lost at this point. The link of blocks can leave one partially
 *        filled block in the upper chain. If files are injected in a clever
 *        order, then many partially-filled blocks can occur. A seek to the
 *        end of the file will recover as many blocks as possible. To make this
 *        completely bug-free requires the trash compactor to be used on the
 *        high block chain (a lot of overhead).
 *     5. Call routine UnPackScreenBuffer(). Call drawall().
 *     6. If the inject worked, then return 0, otherwise return -1.
 *
 */
int inject(file) char *file; {
int i,rec,nlines,nbytes,flg,NN;
int PackScreenBuffer();
int getafile();
struct bucket far *q;

  if(PackScreenBuffer(row)) return -1;
  NN = -1;
  while(1){
    i=putHIblock();
    if(i == 0) continue;
    if(i == -1) break;
    if(i == -2) goto failed;
  }
  if((NN=getafile(file)) < 0) goto failed;
  /* File now in external blocks, but unconverted */
  /* bookkeeping on meminfo[] array - subtle memory overlap problems */
  while(finfo[NN].nbTOT > 0){
    i=startindex(NN) + (--(finfo[NN].nbTOT));
    q= &meminfo[i];
    rec=q->record;
    nlines=q->numlines;
    nbytes=q->numbytes;
    flg=q->flag;
    killinfo(i);
    i=startindex(curfile)+finfo[curfile].nbLOW;
    addinfo(rec,nlines,nbytes,flg,i);
    ++(finfo[curfile].nbTOT);
  }
  killfinfo(&finfo[NN]);
failed:
  UnPackScreenBuffer(row);
  drawall();
  return ((NN < 0) ? -1 : 0);
}

/*
 * GETSLOT
 *
 * Find an open slot in the finfo[] array.
 *
 * Returns index N on success, -1 on failure.
 */

int getslot(){
struct fileinfo *p;
int i;
  for(i=0;i<maxinfo;++i){
    p = &finfo[i];
    if(p->active == 0) {
      p->fname=(char *)0;
      setfinfo(p);
      return i;
    }
  }
  return -1;
}

int corefinfo(NN,s)
int NN;         /* index into finfo[] array */
char *s;        /* file name */
{
char **q;
  q = (char **)&(finfo[NN].fname);
  freeup(q[0]);
  if(!safecore(q,s)){
    return (finfo[NN].active=0);                                /*0=failed*/
    /*failed*/
  }
  return 1;                                                     /*1=worked*/
}

/*
 * STARTINDEX
 *
 * Finds the index j in the meminfo[] array where block
 * info is stored for the file whose info is kept in finfo[N].
 *
 * Returns index j or -1 for failure.
 */
int startindex(N) int N;{
int i,tot;
  if(N>=maxinfo) return -1;
  for(tot=i=0;i<N;++i) tot += finfo[i].nbTOT;
  return tot;
}

getmeminfoindex(n,off) int n; int off; {
int k;
    if(off>=finfo[n].nbTOT) return -1;
    k=startindex(n)+off;
    if(meminfo[k].flag) cvblk(k);  /* Convert block */
    return k;
}

/*
 * ADDINFO
 *
 * Inserts an entry at index j into meminfo[] array.
 *
 */

int addinfo(rec,nlines,nbytes,flg,j)
register int rec,nlines,nbytes,flg,j; {
struct bucket far *q;
int r,nl,nb,f;
/*  if(j >=MAXBLOCK || memmark[MAXBLOCK-1] != 0) return -1; bug fix Aug95 */
  if(j >=MAXBLOCK) return -1;
  do {
    q= &meminfo[j];
    r=q->record;  /* save record info */
    nl=q->numlines;
    nb=q->numbytes;
    f=q->flag;
    q->record = rec;
    q->numlines = nlines;
    q->numbytes = nbytes;
    q->flag = flg;
    if(memmark[j]==0) break;
    rec=r; nlines=nl; nbytes=nb; flg=f;
  } while(++j < MAXBLOCK);
  return 0;
}

/*
 * KILLINFO
 *
 * Kills an entry at index j in meminfo[] array.
 *
 */
int killinfo(j) int j; {
struct bucket far *s,*d;
int i;
  if(j>=MAXBLOCK) return -1;
  for(i=j+1;i<MAXBLOCK;++i){
#if 0
    d= &meminfo[i-1]; s= &meminfo[i];
    d->numbytes = s->numbytes;
    d->numlines = s->numlines;
    d->record   = s->record;
    d->flag     = s->flag;
#else
 segcopy((char far *)&meminfo[i-1],(char far *)&meminfo[i],sizeof(struct bucket));
/*    moveMEM((char *)meminfo[i-1],(char *)meminfo[i],sizeof(struct bucket)); */
#endif
    if(memmark[i]==0) break;
  }
  return 0;
}


void initfinfo(){                        /* Initialize finfo[] array */
extern struct fileinfo *finfo;
extern int maxinfo;
extern char *core();
int i;
    finfo=(struct fileinfo *)core(i=maxinfo*sizeof(struct fileinfo));
    fillchr(&finfo[0],'\0',i);
}

void savefinfo(fiddle) int fiddle; {
extern int markset,markcol; extern LLONG markline;
struct fileinfo *p;
  p= &finfo[curfile];
  p->dirty=fiddle;
  p->setmark=markset;
  p->setmarkcol=markcol;
  p->setmarkline=markline;
}

void getfinfo(fiddle) int *fiddle; {
struct fileinfo *p;
  p= &finfo[curfile];
  fiddle[0]=p->dirty;
  markset=p->setmark;
  markcol=p->setmarkcol;
  markline=p->setmarkline;
}

/*
 * STOWAWAY
 *
 * Stows current file into external blocks, so that another file can
 * be edited.
 *
 * To release the current file and save it for future editing:
 *
 *      1. Set NN=curfile.
 *      2. Call routine PackScreenBuffer(). If this fails, then return
 *         -1.
 *      3. Apply putLOWblock() until the low buffer is empty. Apply
 *         putHIblock() until the high buffer is empty. If anything
 *         goes wrong, then goto 6. We assume that curfile==NN and that
 *         the routines are smart enough to update meminfo[] and finfo[].
 *      4. Set finfo[NN] variables for row, col, line using the current
 *         system variables.
 *      5. Set file active: finfo[NN].active=1.
 *         Return 0.
 *      6. Failed. Call UnPackScreenBuffer() to reload data items to the
 *         screen buffer. Drawall(). Return -1.
 */
int stowaway(){
int i;
struct fileinfo *p;
  while(1){
    i=putHIblock();
/*    if(i == 0) continue; */
    if(i == -1) break;
    if(i == -2) goto failed;
  }
  while(1){
    i=putLOWblock();
/*    if(i == 0) continue; */
    if(i == -1) break;
    if(i == -2) goto failed;
  }
  p = &finfo[curfile];
  p->rowc=row;
  p->colc=col;
  p->curoffset=curoff;
  p->linec=lncount;
  p->active=1;
  return 0;
failed:
  return -1;
}

void setoffset(n) int n; {
  finfo[curfile].curoffset=n;
}

/*
 * SETFILE
 *
 * Sets the file being currently edited to NN
 *
 */
void setfile(NN) int NN;{
register struct fileinfo *p;
  p = &finfo[NN];
  p->active=2;
  row=min(p->rowc,ROWMAX);      /* 1996: Window can change size */
  col=min(p->colc,COLMAX);
  if((lncount=p->linec)==0) lncount=1;
  strcpy(sysfile,p->fname);
  curoff = p->curoffset;
  curfile=NN;
}


/*
 * NEWEDIT
 *
 * Edit a new file already stowed away in external blocks.
 *
 * To edit file NN in finfo[]:
 *
 *      1. Test NN in range 0...(maxinfo-1). Return -1 if invalid.
 *      2. Release current file. Return -1 if it cannot be released.
 *         Set curfile=NN. Set finfo[NN].active=2.
 *         Set row=finfo[NN].rowc, col=finfo[NN].colc, lncount=finfo[NN].linec.
 *      3. Set buffer empty: lbuf=bufbase-1, hbuf=ebuf.
 *         Return 0.
 */
int newedit(NN) int NN;{
  if(NN<0 || NN>=maxinfo) return -1;
  if(PackScreenBuffer(row)) return -1;
  if(stowaway()){
    UnPackScreenBuffer(row);
    drawall();
    bellpressany("No more blocks");
    return -1;
  }
  /*doPURGE();*/
  setfile(NN);
  lbuf=bufbase-1; hbuf=ebuf;
  return 0;
}

/*
 * PACKSCREENBUFFER
 *

 * Copies screen lines to low and high buffers as appropriate.
 * This implies purges to external blocks, hence failure is possible.
 * The routine cleans up the mess in case of failure.
 *
 * Fragmentation can occur because of this routine. The way it happens
 * is for the low or high buffer to be empty, so that no active block
 * can be used to pick up the fragmentation. A clever way to prevent the
 * trouble is to insure that the low and high buffers are non-empty, if
 * possible.
 *
 */
int PackScreenBuffer(row) int row; {
int i;
  deFRAG();
  for(i=0;i<row;++i) {
    if(!loPush(line[i])) {
      while(i--) loPull(sysx);
      return -1;
    }
  }
  for(i=ROWMAX;i>=row;--i) {
    if(!hiPush(line[i])){
      while(i++ <= ROWMAX) hiPull(sysx);
      i=row; while(i--) loPull(sysx);
      return -1;
    }
  }
  return 0;
}

/*
 * deFRAG
 *
 * Insure that both low and high buffers are loaded, to prevent
 * fragmentation.
 */
void deFRAG() {
  if(loPull(sysx)) loPush(sysx);  /*insure low buffer does not fragment */
  if(hiPull(sysx)) hiPush(sysx);  /*insure high buffer does not fragment */
}

/*
 * UNPACKSCREENBUFFER
 *
 * Used after a previous call to PackScreenBuffer() in order to
 * restore lines to the screen. Depends on the cursor row. It should
 * always succeed.
 */
int UnPackScreenBuffer(row) int row; {
register int i;
  for(i=row-1;i>=0;--i) loPull(line[i]);
  for(i=row;i<=ROWMAX;++i) hiPull(line[i]);
  return 0;
}

/*
 * PUTLOWBLOCK
 *
 * Purges a low buffer hunk out to external blocks. Returns 0 on
 * success, -1 if no more low buffer to purge, -2 if an external block
 * cannot be created for the copy. Updates lbuf and meminfo[], finfo[]
 * arrays on success.
 *
 * The routine putLOWblock():
 *
 *      1. Test lbuf<bufbase. If true, then return failure -1.
 *      2. Let N=crBLOCK(). If N == -1, then no block is available, so
 *         in this case return -2.
 *      3. Open a slot in the meminfo[] array and save the record I.
 *      4. Determine the number n of bytes to write (<= SIZEBLOCK) and
 *         the number of lines m. Update meminfo[] with this information
 *         and call CPtoBLOCK(N,bufbase,n) to move the data.
 *      5. Block move: moveMEM(bufbase,bufbase+n,lbuf-bufbase-n)
 *      6. Change lbuf -= n to reflect the purge of data. Return 0.
 */
int putLOWblock(){
int k;
int i,j,lines,N;
struct fileinfo *p;
  if(lbuf<bufbase) return -1;
  if((N=crBLOCK()) == -1) return -2;
  p = &finfo[curfile];
  k=lbuf+1-bufbase; i=0;
  if(k>SIZEBLOCK){
    i=k-SIZEBLOCK; k=SIZEBLOCK;
    while(k>0){ if(bufbase[k-1] == 0) break; --k; ++i;}
  }
  lines=CPtoBLOCK(N,bufbase,k);
  j=startindex(curfile)+p->nbLOW;
  addinfo(N,lines,k,0,j);   /* Such blocks are already converted */
  ++(p->nbLOW);
  ++(p->nbTOT);
  moveMEM(bufbase,bufbase+k,i);
  lbuf -= k; *lbuf=0;
  return 0;
}

/*
 * PUTHIBLOCK
 *
 * Purges a high buffer hunk out to external blocks. Returns 0 on
 * success, -1 if no more high buffer to purge, -2 if an external block
 * cannot be created for the copy. Updates hbuf and meminfo[], finfo[]
 * arrays on success.
 *
 * The routine putHIblock():
 *
 *      1. Test hbuf>=ebuf. If true, then return failure -1.
 *      2. Let I=crBLOCK(). If I == -1, then no block is available, so
 *         in this case return -2.
 *      3. Open a slot in the meminfo[] array and save the record I.
 *      4. Determine the number n of bytes to write (<= SIZEBLOCK) and
 *         the number of lines m. Update meminfo[] with this information
 *         and call CPtoBLOCK(I,ebuf-n,n) to move the data.
 *      5. Block move: moveMEM(hbuf+n,hbuf,ebuf+1-hbuf-n)


 *      6. Change hbuf += n to reflect the purge of data. Return 0.
 *


 */
int putHIblock(){
register int i,j; int r,lines,N;
  if(hbuf>=ebuf) return -1;
  if((N=crBLOCK()) == -1) return -2;
  j=ebuf-hbuf; i=0;
  if(j>SIZEBLOCK){
    i = j-SIZEBLOCK; j=SIZEBLOCK;
    while(j>0){
      if(hbuf[i-1]==0)break; ++i; --j;
    }
  }
  lines=CPtoBLOCK(N,hbuf+i,j);
  r=startindex(curfile)+finfo[curfile].nbLOW;
  addinfo(N,lines,j,0,r);  /* Such blocks are already converted */
  ++(finfo[curfile].nbTOT);
  if(i) moveMEM(hbuf+j,hbuf,i);
  hbuf += j;
  if(hbuf>ebuf) hbuf=ebuf; *ebuf=0;
  return 0;
}

/*
 * GETLOWBLOCK
 *
 * Copies the near low block from external memory into the low buffer.
 * The low work buffer is assumed to be empty.
 *
 * The routine getLOWblock():
 *
 *      1. Let m = finfo[curfile].nbLOW. If m==0, then return -1 for failure.
 *         Let N=startindex(curfile)+m-1, n=meminfo[N]->numbytes,
 *         I=meminfo[N]->record.
 *      2. Test bufbase+n+HEADROOM<hbuf. If false, then return -2.
 *      3. Call CPfromBLOCK(I,bufbase,n). Update lbuf = bufbase+n.
 *         Note that *lbuf == 0 is required by other routines.
 *      4. Call rlBLOCK(I). We are not using it anymore, so it has to be
 *         put back into the free pool.
 *      5. Decrement finfo[NN].nbLOW and nbTOT. Remove array element N from
 *         meminfo[]
 *      6. Return 0 to report success.
 */
int getLOWblock(){
int n,I,k;
struct fileinfo *p;
  p= &finfo[curfile];
  if((n=p->nbLOW)==0) return -1;
  k=getmeminfoindex(curfile,n-1);
  n=meminfo[k].numbytes;
  if(bufbase+n>=hbuf) return -2;
  I=meminfo[k].record;
  CPfromBLOCK(I,bufbase,n);
  lbuf = bufbase+n-1; *lbuf=0;
  rlBLOCK(I);
  --(p->nbLOW);
  --(p->nbTOT);
  killinfo(k);
  return 0;
}

/*
 * GETHIBLOCK
 *
 * Copies the near high block from external memory into the high buffer.
 * The high work buffer is assumed to be empty.
 *
 * The routine getHIblock():
 *
 *      1. Let N = startindex(NN)+finfo[NN].nbLOW. Let I =
 *         meminfo[N]->record. If finfo[NN].nbTOT==finfo[NN].nbLOW, then
 *         return -1 for failure. Let n = meminfo[N]->numbytes.
 *      2. Test lbuf+HEADROOM+n<ebuf. If false, then return -2.
 *      3. Call CPfromBLOCK(I,hbuf=ebuf-n,n).
 *      4. Call rlBLOCK(I). We are not using it anymore, so it has to be
 *         put back into the free pool.
 *      5. Decrement finfo[NN].nbTOT. Remove array element N from
 *         meminfo[].
 *      6. Return 0 to report success.
 *
 */
int getHIblock(){
int n,I,N;
  if((N=getmeminfoindex(curfile,finfo[curfile].nbLOW)) == -1) return -1;
  n=meminfo[N].numbytes;
  if(lbuf+n>=ebuf) return -2;
  I=meminfo[N].record;
  CPfromBLOCK(I,hbuf=ebuf-n,n);
  *ebuf=hbuf[-1]=0;
  rlBLOCK(I);
  --(finfo[curfile].nbTOT);
  killinfo(N);
  return 0;
}

/*
 * NEXTFILE
 *
 * Computes the index 0...(maxinfo-1) of the next file to be edited,
 * measured from the current file index (curfile), in a circular loop.
 * If it can't find anything to edit, it returns 0, the index of the
 * kill ring. So this routine always returns something useful.
 */
int nextfile(n) int n;{
register
int i,flag;
  flag=(n>=0);
  i=abs(n); if(i>=maxinfo) i=0;
  n=i;
  while(1){
    if(finfo[i].active) return i;
    if(flag) ++i; else --i;
    if(i<0) i=maxinfo-1; if(i>=maxinfo) i=0;
    if(i == n) break;
  }
  return 0;
}

/*
 * PRESSANY
 *
 * Wait for a return key.
 */
void pressany(s)char *s;{
extern char *strchr();
  if(s[0]) {bbanner(s," - ");} ePrint("Press return: ");
  clrcon();
  while(strchr("\r\n",getbyte())==(char *)0) ;
}

void bellpressany(s)char *s;{
  bell(); pressany(s);
}

/*
 * ISDIRTY
 *
 * Tests for any dirty files that should be written.
 */
int isdirty(){
register
int i;
  for(i=0;i<maxinfo;++i){
    if(finfo[i].dirty) return 1;
  }
  return 0;
}

/*
 * SHOWDIRTY
 *
 * Displays any dirty files that should be written.
 */
int showdirty(){
register
int i;
  if(!isdirty()) return 0;
  cleardisplay();
  ePrint("[Changes exist]"); crlf();
  for(i=0;i<maxinfo;++i){
    if(finfo[i].dirty) {ePrint(finfo[i].fname); crlf();}
  }
  return (!getyesno(QUIT_PROMPT));
}

/*
 * USEDFILES
 *
 * Returns the number of active files.
 */
int usedfiles(){
register
int i,j;
  for(j=i=0;i<maxinfo;++i) if(finfo[i].active) ++j;
  return j;
}

/*
 * ISINFO
 *
 * Tests finfo array to see if there is a file name match
 */
#if !MSDOS
int isinfo(name) char *name; {
int i,j; char *p;
char myname[128];
  strcpy(myname,name);
  j=strlen(myname);
  for(i=0;i<maxinfo;++i){
    if(finfo[i].active != 0){
      if(strlen(p=finfo[i].fname) != j) continue;
      if(strncmp(p,myname,j)==0) return 1+i;
    }
  }
  return 0;
}
#endif

#if MSDOS
int isinfo(name) char *name; {
int i,j; char *p;
char myname[128];
  strcpy(myname,name);
  cvupper(myname);
  j=strlen(myname);
  for(i=0;i<maxinfo;++i){
    if(finfo[i].active != 0){
      if(strlen(p=finfo[i].fname) != j) continue;
      if(strccmp(p,myname,j)==0) return 1+i;
    }
  }
  return 0;
}
#endif
