/*
 * VG.C    Editor global variables - Wordstar Keys, ANSI terminal
 * WARNING: All globals must be initialized. See V0.C.
 *
 *=========================================================================
 *                             GLOBAL VARIABLES
 *=========================================================================
 */
#define KEYDEFS 1       /* include key definitions from v.h */
#include "v.h"
#if MSDOS
#if MONO
#define TITLEATTR       7+8     /* boldface */
#define WINDOWATTR      7       /* white background, black letters */
#define BORDERATTR      7+8     /* boldface */
#define REVERSEVIDEO    0x70    /* reverse video */
#define BOLDFACEATTR    7+8     /* boldface */
#define OTHERATTR       7       /* white background, black letters */
#endif
/* IBMPC: Use 0F, 07, 0F for mono 1F, 13, 1F for color (blue & white) */
#if !MONO
#define TITLEATTR       31       /* boldface */
#define WINDOWATTR      19       /* dark blue background, white letters */
#define BORDERATTR      31       /* boldface */
#define REVERSEVIDEO    0x70     /* reverse video */
#define BOLDFACEATTR    31       /* boldface */
#define OTHERATTR       48       /* light blue background, black letters */
#endif
/*extern unsigned _heaplen=(unsigned)0;*/
#endif
#if !MSDOS
#define TITLEATTR       0x80    /* boldface */
#define WINDOWATTR      0x07    /* normal text background/foreground */
#define BORDERATTR      0x70    /* reverse video */
#define REVERSEVIDEO    0x70    /* reverse video */
#define BOLDFACEATTR    0x80    /* doesn't actually exist */
#define OTHERATTR       7       /* white background, black letters */
#endif

char __fff[2]={'P','I'};        /* marks start of data area */
int _egavga = MONOEGAVGA;
int abortkey = CTRLU;
int markset=0;
int markcol=0;
LLONG markline=0;
int SYSATT=OTHERATTR;
int PRTleft=5,PRTtop=5,PRTbot=6,PRTlpp=55,PRTff=1;
int TABINSERT=0;
int repeats=1;
int repkey=0;
unsigned lastkey=0;
int MAXKILLER=400;
struct bigarray far *killerlist=0;
int killerlen=0;
int mouseswitch=0;      /* X-windows mouse. 1=on, 0=off */
int hsens=8;            /* 8=default mickeys/8 pixels. 0=off MSDOS only. */
int vsens=16;           /* 16=default mickeys/8 pixels. 0=off MSDOS only.*/
int KEYMODE=1;          /* 0=none, 1=emacs, 2=wdstar, 3=wdperf */
int cursorCH=1;         /* VGA:  ch=1, cl=13 for cursor shape */
int cursorCL=13;
int swapswitch=1;       /* 1=on, 0=off swap to disk on system() */
int zero = '\200';      /* Search string char to match begin/end line */
int zeroleft=0;         /* TRUE if srcharg[0] is a zero token */
int zeroright=0;        /* TRUE if tailchar(srcharg) is a zero token */
char *MATHFMT=0;        /* Math format in printf style syntax "%.08g";*/
int blockflag=0;        /* Prompt for block read parameters */
int regdef=0;           /* 0=Region by lines, 1=by columns (toggle) */
int ACTIONSTART=1;      /* 0=start UnTitled, 1=start with Menu */
#if MSDOS  /* Mapping of GREY keys on the keypad to other keycodes */
           /* The code appears in routine ccBIOS (v8.c) */
int GREYplus=0x8300;    /* Grey plus==0x4e2b mapped to 0x8300=="Alt= " */
int GREYast=0x0c1f;     /* Grey asterisk==0x372a mapped to 0x0c1f=="Ctrl _" */
int GREYent=0x8300;     /* Grey enter==0xe00d mapped to 0x8300=="Alt =" */
int STASHmin=6;         /* Memory blocks reserved for F9 string copies */
int SUSPENDexit=0;      /*Suspend on ctrl-KX "Save then exit" FILE menu. */
#endif
#if !MSDOS
int ansimode=1;         /* Flag for ansi mode (0=off) */
int textfgcolor=0;      /* Foreground text color 30-37 ANSI mode (0=default) */
int textbgcolor=0;      /* Background text color 40-47 ANSI mode (0=default) */
int menufgcolor=37;     /* Foreground menu color 30-37 ANSI mode (37=white) */
int menubgcolor=44;     /* Background menu color 40-47 ANSI mode (44=blue) */
char *UNIXtextfgbg=0;   /* Unix text foreground+background ANSI */
char *UNIXmenufgbg=0;   /* Unix menu foreground+background ANSI */
char *UNIXdefaultfgbg=0;/* Unix default foreground+background ANSI */
#endif

int
  insmode=0,            /* insert mode toggle                   */
  tabstop=0,            /* tabstop variable                     */
  row = 0,              /* row position 0...23                  */
  col = 0,              /* column position 0...79               */
  macmax = 0,           /* maximum index in macbuf[]            */
  macrep = 1,           /* number of times to repeat macro      */
  macind = 0,           /* current index into macbuf[]          */
  macrun = 0,           /* macro running flag                   */
  sysarg = 0,           /* ENTER key numerical argument         */
  record = 0,           /* record keystrokes flag               */
  popcount = 1,         /* number of lines in push buffer       */
  nodisp = 0,           /* display flag, 0=on, 1=off            */
  statblank = 1;        /* status line has been erased          */
#if MSDOS
int
  STOPS=8,              /* tab stop increment                   */
  ROWMAX = 23,          /* rows numbered 0..22                  */
  COLMAX = 79,          /* columns numbered 0..79               */
  MAXLN = 160,          /* longest line length                  */
  MAXROWS = 24,         /* most rows/screen, >= 1+ROWMAX        */
  DOSTATUS = 1;         /* Print status line during edit        */
#endif
#if !MSDOS
int
  STOPS=8,              /* tab stop increment                   */
  ROWMAX = 22,          /* rows numbered 0..22                  */
  COLMAX = 79,          /* columns numbered 0..79               */
  MAXLN = 160,          /* longest line length                  */
  MAXROWS = 40,         /* most rows/screen, >= 1+ROWMAX        */
  DOSTATUS = 1,         /* Print status line during edit        */
  PIPEopen=0;           /* Status of open pipe, unix sys5/bsd   */
#endif
int
  INDENAUTO = 1,        /* indent flag                          */
  HangingIndent=1,      /* Allow hanging indents                */
  WRDWRP = 0,           /* word wrap toggle                     */
  margin = 72,          /* initial right margin                 */
  BITSTRIP = 0,         /* strip high bits, 1=on, 0=off         */
  DETABBER = 1,         /* process tabs to spaces (1=on,0=off)  */
  BLANKSTRIP=0,         /* Strip blanks off end of line (1=on)  */
  TSTOPS = 8,           /* screen tab stop                      */
  FOLDCASE=1,           /* fold case on search                  */
  MAXMB=256,            /* size of macro recording buffer       */
  INSMD=1,              /* State of initial insert mode         */
  drawstyle=1,          /* Style of box/line-drawing (1-5)      */
#if CRLFBOX             /* input/output file types              */
  intexttype = CRLFtexttype,    /* 1=cr/lf, 2=cr, 3=lf          */
  outtexttype = CRLFtexttype,
#endif
#if CRBOX
  intexttype = CRtexttype,
  outtexttype = CRtexttype,
#endif
#if LFBOX
  intexttype = LFtexttype,
  outtexttype = LFtexttype,
#endif
  titlattr = TITLEATTR, /* Window title color attribute         */
  windattr = WINDOWATTR,/* Window color attribute               */
  bordattr=BORDERATTR,  /* Window border color attribute        */
  boxcharset=BOXCHAR,   /* Box characterset 0=text,1=latin1,2=latin2 */
  BACKUPS=1,            /* 0=FALSE,1=$HOME/PIbackups,2=./PIbackups */
  EMACSMODE=0;          /* cr inserts cr/lf by default          */
#if MSDOS
char *
  BROWSER="iexplorer";  /* Choose a default browser */
#else
char *
  BROWSER="netscape";   /* Choose a default browser */
#endif
int
  drawline=0;           /* box/line drawing switch, 0=off,1=on  */
LLONG
  lncount = 0;          /* line number variable                 */
char
  PiVersion[] =         /* Version string for PI editor compile */
   {VERSIONofPI};       /* Puts version info into the executable */
char *
  progname=0;           /* Program name from argv[0] */
char                    /* Directory name for backups */
  *PIBACKUPS="PIbackups";
                        /* name of notepad file                 */
char NOTEPAD[]={"NotePad"};
                        /* name of untitled file                */
char UNTITLED[] ={"UnTitled"};
char HELPSTR[] = {" [Menu=four ESC]"};
char QUIT_PROMPT[]={"Quit Editor"};
char INSERTMODE[]={" [NoInsert]"};
char LINEDRAWMODE[]={"[Line Drawing]"};
char AUTHOR[]={"G.B.Gustafson, 155 So 1400 East #233, SLC, UT 84112-0090"};
char ADDRESSofAUTHOR[]={"gustafson@math.utah.edu, (801) 581-6879"};

char *cd;               /* connected dir pointer                */
char
  *SHELL=SHELLDEFAULT;  /* Name of command shell                */
char
  *srcharg,             /* pointer to search argument string    */
  *lastarg,             /* pointer to last getstr arg string    */
  *replarg,             /* pointer to replace argument string   */
  *sysfile,             /* command line filename                */
  *sysv,                /* pointer to system scratch buffer     */
  *sysx,                /* pointer to system scratch buffer     */
  *sysvv,               /* pointer to system scratch buffer     */
  *bufbase=(char *)0,   /* edit buffer base (absolute)          */
  *lbuf,                /* lower buffer end (movable)           */
  *hbuf,                /* high buffer start (movable)          */
  *ebuf,                /* end of edit buffer + 1 (movable)     */
  *scrbuf,              /* screen buffer pointer (fixed)        */
  *macbuf,              /* memorization buffer pointer (fixed)  */
  *optbuf;              /* pointer to optional line buffer      */
char
  **line;               /* pointers to 24 screen lines          */
int
  taberr=0,             /* error count variable for tabs        */
  HEADROOM=0,           /* must be > 1+MAXLN+SIZEBLOCK          */
  LINESIZE=0,           /* usually (1+ROWMAX)*sizeof(char *)    */
  SCRSIZE=0,            /* usually (1+MAXLN)*(1+ROWMAX)         */
                        /* but also SCRSIZE >= HEADROOM         */
  FARSCROLL=0,          /* must be > ROWMAX                     */
  halfdone=0;           /* measure dirty screen half-displayed  */

char  *termtype;        /* pointer to terminal type string      */

#if !MSDOS
char   *rs_termcap    = "";             /* reset terminal */
char   *is_termcap    = "";             /* init terminal */
char   *ks_termcap    = "";             /* start keypad shifted mode */
char   *ke_termcap    = "";             /* exit keypad shifted mode */
char   *al_termcap    = "";             /* insert line */
char   *dl_termcap    = "";             /* delete line */
char   *ce_termcap    = "";             /* erase to end of line */
char   *cd_termcap    = "";             /* clear to end of display */
char   *cm_termcap    = "";             /* cursor motion */
char   *cs_termcap    = "";             /* change scrolling region */
char   *sf_termcap    = "";             /* scroll forward */
char   *sr_termcap    = "";             /* scroll reverse */
char   *bl_termcap    = "\7";           /* audible bell */
char   *pc_termcap    = "";             /* pad char (null) */
char   *REVVIDEO      = "";             /* enter inverse video (so) */
char   *NORMVIDEO     = "";             /* exit inverse/bold video (se) */
char   *BOLDF         = "";             /* enter boldface chars (md) */
char   *ERACHR        = "\b\40\b";      /* erase char left */
char   *INIFILE       ="";              /* keyboard file name */
int    HASSCROLL      = 0;              /* cs && sf && sr */
int    HASINSERTLINE  = 0;              /* HASSCROLL || *al_termcap */
int    HASDELETELINE  = 0;              /* HASSCROLL || *dl_termcap */
int    ospeed         = 0;              /* output speed of terminal */
#endif

#if MSDOS
#if ANSISYS
char   *rs_termcap    = "";             /* reset terminal */
char   *is_termcap    = "";             /* init terminal */
char   *ks_termcap    = "";             /* start keypad shifted mode */
char   *ke_termcap    = "";             /* exit keypad shifted mode */
char   *al_termcap    = "\033[L";       /* insert line */
char   *dl_termcap    = "\033[M";       /* delete line */
char   *ce_termcap    = "\033[K";       /* erase to end of line */
char   *cd_termcap    = "\033[J";       /* clear to end of display */
char   *cm_termcap    = "\033[%d;%dH";  /* cursor motion */
char   *cs_termcap    = "";             /* change scrolling region */
char   *sf_termcap    = "";             /* scroll forward */
char   *sr_termcap    = "";             /* scroll reverse */
char   *bl_termcap    = "\7";           /* audible bell */
char   *pc_termcap    = "\200";         /* pad char (null) */
char   *REVVIDEO      = "\033[7m";      /* enter inverse video (so) */
char   *NORMVIDEO     = "\033[0m";      /* exit inverse/bold video (se) */
char   *BOLDF         = "\033[1m"  ;    /* enter boldface chars (md) */
#endif

char   *ERACHR        = "\b\40\b";      /* erase char left */
char   *INIFILE       ="";              /* keyboard file name */
int    HASSCROLL      = 0;              /* cs && sf && sr */
int    HASINSERTLINE  = 1;              /* HASSCROLL || *al_termcap */
int    HASDELETELINE  = 1;              /* HASSCROLL || *dl_termcap */
int    ospeed         = 0;              /* output speed of terminal */
#endif

#if MSDOS
#define MAXFNAME 128    /* length of largest file name */
#define MAXFILES 50     /* allow fifty files at once */
#endif

#if !MSDOS
#define MAXFNAME 256    /* length of largest file name */
#define MAXFILES 100    /* allow 100 files at once */
#endif

#define MKLEN 20
#ifndef SIZBLK
#define SIZBLK   4096   /* depends on disk controller & OS */
#endif
#ifndef MAXBL
#define MAXBL    640    /* depends on OS and installed memory */
#endif
#ifndef MAXBLxms
#define MAXBLxms  1024   /* Relevant for MSDOS with HIMEM.SYS */
#endif
#define NUMMACBUF 100    /* number of macro buffers              */

int MACNUM=NUMMACBUF;   /* Global counter for macro buffers     */
int MAXFN=MAXFNAME;     /* max length of a file name */
int SIZEBLOCK=SIZBLK;
int SIZEKBLOCK=SIZBLK/1024; /* Size in kilobytes */
int USEDBLOCK=0;
int MAXBLOCK=MAXBL;     /* Gets changed in v0.c to reflect actual memory */
int MAXXMS=MAXBLxms;
int maxinfo=MAXFILES;  /* possible file handles */

char **macrobuf;
int *macromax;

#if 0  /* See v.h */
struct bucket {
 int record;    /* record in memblock[] array */
 int numlines;  /* number of lines in bucket */
 int numbytes;  /* number of bytes in bucket */
 int flag;      /* 0 if converted, 1 if not */
};
#endif

#if 0
struct bucket **  /* bucket info array */
meminfo;
#else
struct bucket far *  /* bucket info array */
meminfo;
#endif

char far *
memmark;
unsigned far *
handles;                /* handles for TURBOC xms routines */

FARSTR far *            /* bucket addresses */
memblock;
#if 0
struct fileinfo {
int active;     /* 0=not used, 1=all external, 2=uses main buffer */
char *fname;    /* file name */
int nbLOW;      /* number of low blocks used by file */
int nbTOT;      /* total number of blocks used by file */
int rowc;       /* cursor row, not used if active=2 */
int colc;       /* cursor col, not used if active=2 */
LLONG linec;    /* cursor line, not used if active=2 */
int dirty;      /* 0 if never touched, nonzero otherwise */
int curoffset;  /* screen offset, see drawall() */
int setmark;    /* text marker flag, 1=on,0=off */
int setmarkcol; /* absolute column marker where marker was set */
LLONG
 setmarkline;   /* line number where marker was set. */
};
#endif

int curfile = 1;        /* currently active file 0...(maxinfo-1) */
int curoff = 0;         /* current screen offset, see drawall() */

struct fileinfo
*finfo;
/*finfo[MAXFILES];*/

#if 0
struct keybrd {
  int value;
  char *seq;
};
#endif
struct keybrd ourkeys[] = {
#if MSDOS
        {ENTERKEY     , "\33\33"        },      /*      Escape             */
        {TABKEY       , "\t"            },      /*      Ctrl-I (tab)       */
        {WORDAHEAD    , "\6",           },      /*      Ctrl-F word ahead  */
        {RETURNKEY    , "\r"            },      /*      Ctrl-M (return)    */
        {EMACSRETURNKEY , "\12"         },      /*      Ctrl-J (linefeed)  */
        {WORDBACK     , "\1",           },      /*      Ctrl-A word back   */
        {UPARROW      , "\5"            },      /*      Ctrl-E             */
        {DOWNARROW    , "\30"           },      /*      Ctrl-X             */
        {FILEBOTTOM   , "\21\3"         },      /*      Ctrl-Q,Ctrl-C      */
        {LEFTARROW    , "\23"           },      /*      Ctrl-S             */
        {EXTLEFTARROW , "\21\23"        },      /*      Ctrl-Q,Ctrl-S      */
        {RIGHTARROW   , "\4"            },      /*      Ctrl-D             */
        {EXTRIGHTARROW, "\21\4"         },      /*      Ctrl-Q,Ctrl-D      */
        {HOMEKEY      , "\21\5"         },      /*      ctrl-Q,ctrl-E      */
        {REVHOMEKEY   ,"\21\30"         },      /*      Ctrl-Q,Ctrl-X      */
        {INSERTLINE   , "\16"           },      /*      Ctrl-N             */
        {DELLINE      , "\31"           },      /*      Ctrl-Y             */
        {DELCHAR      , "\7"            },      /*      Ctrl-G             */
        {INSMODE      , "\26"           },      /*      Ctrl-V             */
        {QUERYREPLACE , "\21\1"         },      /*      Ctrl-Q,Ctrl-A      */
        {NEWSEARCH    , "\21\6"         },      /* ctrl-QF new search str  */
        {FWDSEARCH    , "\17f"          },      /* ctrl-O,f                */
        {REVSEARCH    , "\17b"          },      /* ctrl-O,b                */
        {PAGEFORWARD  , "\3"            },      /*      Ctrl-C             */
        {LINEFORWARD  , "\32"           },      /*      Ctrl-Z             */
        {FILETOP      , "\21\22"        },      /*      Ctrl-Q,Ctrl-R      */
        {LINEBACK     , "\27"           },      /*      Ctrl-W             */
        {PAGEBACK     , "\22"           },      /*      Ctrl-R             */
        {ERASEKEY     , "\21\24"        },      /*      ctrl-Q,Ctrl-T      */
        {QPUSHKEY     , "\17\03"        },      /*      Ctrl-O,Ctrl-C      */
        {PUSHKEY      , "\13\03"        },      /*      Ctrl-K,Ctrl-C      */
        {QPOPKEY      , "\17\26"        },      /*      Ctrl-O,Ctrl-V      */
        {QZAPKEY      , "\17\32"        },      /*      Ctrl-O,Ctrl-Z      */
        {POPKEY       , "\13\26"        },      /*      Ctrl-K,Ctrl-V      */
        {SAVE_EXIT    , "\13\30"        },      /*      Ctrl-K,Ctrl-X      */
        {DSKFILES     , "\13\6"         },      /*      Ctrl-K,Ctrl-F      */
        {LOAD         , "\13\14"        },      /*      Ctrl-K,Ctrl-L      */
        {INJECT       , "\13\22"        },      /*      Ctrl-K,Ctrl-R      */
        {SPLITLINE    , "\17\16"        },      /*      Ctrl-O,Ctrl-N      */
        {BACKUP       , "\13\23"        },      /*      Ctrl-K,Ctrl-S      */
        {SAVEASKEY    , "\13\27"        },      /*      Ctrl-K,Ctrl-W      */
        {CONTROLENTRY , "\20"           },      /*      Ctrl-P             */
        {BAILOUT      , "\25\25"        },      /*      Ctrl-U,Ctrl-U      */
        {GRABTEXT     , "\177"          },      /*      DELETE             */
        {ADDBUFFER    , "\17\13"        },      /*      Ctrl-O,Ctrl-K      */
        {DELMANYLINES , "\17\31"        },      /*      Ctrl-O,Ctrl-Y      */
        {OPTPUSHKEY ,   "\17\20"        },      /*      Ctrl-O,Ctrl-P      */
        {ERASELINE    , "\21\31"        },      /*      Ctrl-Q,Ctrl-Y      */
        {SCRAPBUFFER  , "\13\21"        },      /*      Ctrl-K,Ctrl-Q      */
        {SETTABS      , "\17\24"        },      /* ctrl-O,ctrl-T           */
        {SETSTATUS    , "\17\23"        },      /* ctrl-O,ctrl-S           */
        {SETAUTO      , "\17\11"        },      /* ctrl-O,ctrl-I           */
        {SETHANGING   , "\17\25"        },      /* ctrl-O,ctrl-U           */
        {OPTMATH      , "\17i"          },      /* ctrl-O,i optbuf math    */
        {OPTHEX       , "\17H"          },      /* ctrl-O,H hextobase10    */
        {OPTOCT       , "\17O"          },      /* ctrl-O,H octtobase10    */
        {SWAPSW,        "\17!"          },      /* ctrl-O,! swap switch    */
        {REFORMKEY    , "\2"            },      /* ctrl-B is reform        */
        {REVTABKEY     ,"\21\t"         },      /* ctrl-Q,ctrl-I           */
        {COMPLETEKEY  , "\17h"          },      /* ctrl-O,h keymap editor  */
        {MACROLIBRARY,  "\17e"          },      /* ctrl-O,e macro lib edit */
        {RECORDING    , "\17m"          },      /* ctrl-O,m memorize steps */
        {RUNMEMORIZE  , "\17r"          },      /* ctrl-O,r run macro      */
        {RUNPROGRAM   , "\17\22"        },      /* ctrl-O,ctrl-R           */
        {RUNBACKGROUND, "\17\21"        },      /* ctrl-O,ctrl-Q           */
        {RUNMYPROGRAM , "\17R"          },      /* ctrl-O,R                */
        {RUNHELP      , "\17\10"        },      /* ctrl-O,ctrl-H           */
        {WORDWRAP     , "\17\27"        },      /* ctrl-O,ctrl-W           */
        {NEXTEDIT     , "\f"            },      /* ctrl-L (next buffer)    */
        {PREVEDIT     , "\21\f"         },      /* ctrl-QL (prev buffer)   */
        {SAVE_NEXT    , "\13\4"         },      /* ctrl-KD, save+continue  */
        {EXTENDEDCHAR , "\17\5"         },      /* ctrl-OE, prev |= 128    */
        {SETDETAB     , "\17\4"         },      /* ctrl-OD, detab toggle   */
        {BACKTOGGLE   , "\17\2"         },      /* ctrl-OB, toggle backups */
        {OPTIONSET    , "\17\17"        },      /* ctrl-OO, option settings*/
        {FOLDSRCH     , "\17\6"         },      /* ctrl-OF, togg fold case */
        {MACROKEY     , "\17s"          },      /* ctrl-O,s, save macro    */
        {DISPLAYMACRO,  "\17\61"        },      /* reveal macro codes      */
        {TSRKEY       , "\13\32"        },      /* ctrl-KZ, kill process   */
        {CASELOWER    , "\17l"          },      /* ctrl-O,l case char lower*/
        {CASELLOWER   , "\17L"          },      /* ctrl-O,L case line lower*/
        {CASEUPPER    , "\17u"          },      /* ctrl-O,u case char upper*/
        {CASELUPPER   , "\17U"          },      /* ctrl-O,U case line upper*/
        {CASECAPITAL  , "\17C"          },      /* ctrl-O,C word capitalize*/
        {GOTOKEY      , "\17\7"         },      /* ctrl-OG, goto line #    */
        {MENUKEY      , "\037"          },      /* ctrl-underline, menu    */
        {CENTERTEXT   , "\17c"          },      /* ctrl-O,c center text    */
        {APPENDLINE   , "\17\1"         },      /* ctrl-OA, app line to NP */
        {KILLNOTEPAD  , "\17\30"        },      /* ctrl-OX, Clear NotePad  */
        {NEWLOAD      , "\13\25"        },      /* ctrl-KU, new untitled   */
        {RELOAD       , "\013\05"       },      /* ctrl-KE, reload file    */
        {COPYBLOCK    , "\13c"          },      /* ctrl-K,c copy block     */
        {MOVEBLOCK    , "\13m"          },      /* ctrl-K,m move block     */
        {PASTEBLOCK   , "\13p"          },      /* ctrl-K,p paste block    */
        {MANYRUNMEM   , "\17\12"        },      /* ctrl-OJ Run macro many  */
        {LINEDRAWKEY  , "\17\14"        },      /* ctrl-OL Setup line draw */
        {MENUBOXSET   , "\21b"          },      /* ctrl-Q,b Menu box chars */
        {SETTEXTTYPE  , "\13\24"        },      /* ctrl-KT Set In/Out type */
        {NAMECHANGE   , "\13\16"        },      /* ctrl-KN Change filename */
        {FOREIGNKEY   , "\34"           },      /* ctrl-\ swap foreignkey  */
        {SETMARK      , "\13\2"         },      /* ctrl-KB set block mark  */
        {SWAPMARK     , "\13\13"        },      /* ctrl-KK swap mark       */
        {REVEALMARK   , "\13s"          },      /* ctrl-K,s show block     */
        {CHARTRANSPOSE, "\17t"          },      /* ctrl-O,t transpose chars*/
        {LINETRANSPOSE, "\17T"          },      /* ctrl-O,T Transpose lines*/
        {WORDERASE    , "\24"           },      /* ctrl-T Erase word       */
        {PRINTFILE    , "\13\20"        },      /* ctrl-KP Format & print  */
        {SETPRINTER   , "\17P"          },      /* ctrl-O,p printer setup  */
        {REPEATKEY    , "\21\21"        },      /* ctrl-QQ repeat count    */
        {POPLIST,       "\17&"          },      /* Recover kill list       */
        {PURGELIST,     "\17X"          },      /*ctrl-O,X Purge kill list */
        {MOUSEPRESS,    "\33[M"         },      /* Mouse entry as escapes  */
        {SETBUFFER,     "\13\01"        },      /* ctrl-KA Change buffer   */
        {LFWDSEARCH,    "\17F"          },      /*  Line Search forward    */
        {LREVSEARCH,    "\17B"          },      /*  Line Search reverse    */
        {ZEROTOKEN,     "\17z"          },      /*  Insert zero token      */
        {CENTERREFRESH, "\17p"          },      /* Ctrl-O,p Center Refresh */
        {OPTMATHFLOAT , "\17j"          },      /* ctrl-O,j optbuf cv2 flo */
        {OPTEVALEXPR,   "\17k"          },      /* ctrl-O,k apply eval expr*/
        {MATHFORMAT ,   "\17\15"        },      /* ctrl-OM set math format */
        {VIDEOMODE    , "\17v"          },      /* ctrl-O,v Set video mode */
        {ENTERKEY     , "\200\203"      },      /*      ALT =              */
        {FWDSEARCH    , "\200?"         },      /* function F5             */
        {REVSEARCH    , "\200@"         },      /* function F6             */
        {QPUSHKEY     , "\200f"         },      /*      Ctrl-F9            */
        {QPOPKEY      , "\200g"         },      /*      Ctrl-F10           */
        {REVTABKEY     ,"\200\17"       },      /* shift tab               */
        {UPARROW      , "\200H"         },      /* up arrow                */
        {DOWNARROW    , "\200P"         },      /* down arrow              */
        {LEFTARROW    , "\200K"         },      /* left arrow              */
        {RIGHTARROW   , "\200M"         },      /* right arrow             */
        {HOMEKEY      , "\200w"         },      /* ctrl-HOME               */
        {INSERTLINE   , "\200="         },      /* function F3             */
        {DELLINE      , "\200>"         },      /* function F4             */
        {PAGEFORWARD  , "\200Q"         },      /* PgDn                    */
        {PAGEBACK     , "\200I"         },      /* PgUp                    */
        {LINEFORWARD  , "\200v"         },      /* ctrl-PgDn               */
        {LINEBACK     , "\200\204"      },      /* ctrl-PgUp               */
        {RUNMEMORIZE  , "\200A"         },      /* function F7             */
        {PUSHKEY      , "\200C"         },      /* function F9             */
        {POPKEY       , "\200D"         },      /* function F10            */
        {ADDBUFFER    , "\200W"         },      /* shift Function F4       */
        {RECORDING    , "\200B"         },      /* function F8             */
        {REVHOMEKEY   ,"\200u"          },      /* ctrl-END key            */
        {EXTLEFTARROW, "\200G"          },      /* HOME KEY                */
        {EXTLEFTARROW, "\200s"          },      /* ctrl-leftarrow          */
        {EXTRIGHTARROW,"\200O"          },      /* END KEY                 */
        {EXTRIGHTARROW,"\200t"          },      /* ctrl-rightarrow         */
        {DELCHAR      , "\200S"         },      /* DEL key                 */
        {INSMODE      , "\200R"         },      /* INS key                 */
        {RUNPROGRAM   , "\200<"         },      /* function F2             */
        {RUNMYPROGRAM , "\200U"         },      /* function shift-F2       */
        {RUNBHELP     , "\200h"         },      /* Alt F1 Brief help       */
        {RUNHELP      , "\200T"         },      /* Shift F1 Full help      */
        {MACROLIBRARY,  "\200^"         },      /* ctrl-F1 macro lib edit  */
        {COMPLETEKEY  , "\200_"         },      /* ctrl-F2 keymap editor   */
        {CENTERREFRESH, "\200;"         },      /* F1 Center Refresh       */
        {MACROKEY     , "\200\201"      },      /* alt-0, select macro 1-9 */
        {DISPLAYMACRO,  "\200\200"      },      /* reveal macro codes      */
        {TSRKEY       , "\200-"         },      /* ALT-X,   kill process   */
        {CENTERTEXT   , "\200."         },      /* ALT-C, center text line */
        {APPENDLINE   , "\200V"         },      /* shift-F3 app line to NP */
        {MANYRUNMEM   , "\200Z"         },      /* shift-F7 Run macro many */
        {FOREIGNKEY   , "\200\205"      },      /* F11=(0,5) swap foreign  */
        {CHARTRANSPOSE, "\200\24"       },      /* Alt-T transpose chars   */
        {LINETRANSPOSE, "\200&"         },      /* Alt-L Transpose lines   */
        {ZEROTOKEN,     "\200\3"        },      /*  Insert zero token      */
        {SHRINKWINDOW,  "\17-"          },      /* Resize window rows+cols */
        {OPTEVALEXPR,   "\200\206"      },      /* F12 apply eval expr*/
        {SETBOOKMARK,   "\013\060"      },      /* Set bookmark 0          */
        {GOBOOKMARK,    "\021\060"      },      /* GOTO bookmark 0         */
#endif
#if PIINILOAD
#if !MSDOS
{MENUKEY, "\037"},
{MENUKEY, "\033Ok"},
{MENUKEY, "\033[209z"},
{MENUKEY, "\033[4z"},
{MENUKEY, "\033[P"},
{MENUKEY, "\033[29~"},
{ENTERKEY, "\033\E"},
{ENTERKEY, "\033OM"},
{ENTERKEY, "\033[208z"},
{TABKEY, "\011"},
{RETURNKEY, "\015"},
{EMACSRETURNKEY, "\012"},
{REVTABKEY, "\021\011"},
{WORDAHEAD, "\006"},
{WORDBACK, "\001"},
{UPARROW, "\005"},
{UPARROW, "\033OA"},
{UPARROW, "\033Ox"},
{UPARROW, "\033[215z"},
{UPARROW, "\033[A"},
{DOWNARROW, "\030"},
{DOWNARROW, "\033OB"},
{DOWNARROW, "\033Or"},
{DOWNARROW, "\033[221z"},
{DOWNARROW, "\033[B"},
{LEFTARROW, "\023"},
{LEFTARROW, "\033OD"},
{LEFTARROW, "\033Ot"},
{LEFTARROW, "\033[217z"},
{LEFTARROW, "\033[D"},
{RIGHTARROW, "\004"},
{RIGHTARROW, "\033OC"},
{RIGHTARROW, "\033Ov"},
{RIGHTARROW, "\033[219z"},
{RIGHTARROW, "\033[C"},
{EXTRIGHTARROW, "\021\004"},
{EXTRIGHTARROW, "\033[212z"},
{EXTRIGHTARROW, "\033[220z"},
{EXTRIGHTARROW, "\033Oq"},
{EXTRIGHTARROW, "\033Oe"},
{EXTRIGHTARROW, "\033[4~"},
{EXTRIGHTARROW, "\033O\220"},
{EXTRIGHTARROW, "\033OF"},
{EXTLEFTARROW, "\021\023"},
{EXTLEFTARROW, "\033[211z"},
{EXTLEFTARROW, "\033[214z"},
{EXTLEFTARROW, "\033Ow"},
{EXTLEFTARROW, "\033O\200"},
{EXTLEFTARROW, "\033[1~"},
{EXTLEFTARROW, "\033OH"},
{HOMEKEY, "\021\005"},
{HOMEKEY, "\033Ou"},
{HOMEKEY, "\033[218z"},
{HOMEKEY, "\033[G"},
{HOMEKEY, "\033OE"},
{REVHOMEKEY, "\021\030"},
{FILETOP, "\021\022"},
{FILETOP, "\033[210z"},
{FILETOP, "\033Om"},
{FILEBOTTOM, "\021\003"},
{FILEBOTTOM, "\033[213z"},
{FILEBOTTOM, "\033Ol"},
{LINEFORWARD, "\032"},
{LINEBACK, "\027"},
{PAGEFORWARD, "\003"},
{PAGEFORWARD, "\033[222z"},
{PAGEFORWARD, "\033[6z"},
{PAGEFORWARD, "\033Os"},
{PAGEFORWARD, "\033[6~"},
{PAGEBACK, "\022"},
{PAGEBACK, "\033[216z"},
{PAGEBACK, "\033[5z"},
{PAGEBACK, "\033Oy"},
{PAGEBACK, "\033[5~"},
{GOTOKEY, "\017\007"},
{CENTERREFRESH, "\017p"},
{CENTERREFRESH, "\033[[A"},
{CENTERREFRESH, "\033[11~"},
{CENTERREFRESH, "\033[224z"},
{CENTERREFRESH, "\033OP"},
{INSERTLINE, "\033[13~"},
{INSERTLINE, "\016"},
{INSERTLINE, "\033[194z"},
{INSERTLINE, "\033[25~"},
{INSERTLINE, "\033[[C"},
{INSERTLINE, "\033[226z"},
{INSERTLINE, "\033OR"},
{DELLINE, "\033[14~"},
{DELLINE, "\031"},
{DELLINE, "\033[195z"},
{DELLINE, "\033[26~"},
{DELLINE, "\033[[D"},
{DELLINE, "\033[227z"},
{DELLINE, "\033OS"},
{DELMANYLINES, "\017\031"},
{DELCHAR, "\007"},
{DELCHAR, "\033[3z"},
{DELCHAR, "\033[3~"},
{DELCHAR, "\033On"},
{INSMODE, "\026"},
{INSMODE, "\033Op"},
{INSMODE, "\033[2z"},
{INSMODE, "\033[2~"},
{ERASEKEY, "\021\024"},
{ERASELINE, "\021\031"},
{SPLITLINE, "\017\016"},
{CONTROLENTRY, "\020"},
{PUSHKEY, "\033[20~"},
{PUSHKEY, "\013\003"},
{PUSHKEY, "\033[200z"},
{PUSHKEY, "\033[33~"},
{PUSHKEY, "\033[232z"},
{POPKEY, "\033[21~"},
{POPKEY, "\013\026"},
{POPKEY, "\033[201z"},
{POPKEY, "\033[34~"},
{POPKEY, "\033[233z"},
{POPLIST, "\017&"},
{PURGELIST, "\017X"},
{FOREIGNKEY, "\034"},
{SETBOOKMARK, "\013\060"},
{GOBOOKMARK, "\021\060"},
{CENTERTEXT, "\017c"},
{CHARTRANSPOSE, "\017t"},
{LINETRANSPOSE, "\017T"},
{WORDERASE, "\024"},
{NEWSEARCH, "\021\006"},
{FWDSEARCH, "\033[15~"},
{FWDSEARCH, "\017f"},
{FWDSEARCH, "\033[196z"},
{FWDSEARCH, "\033[28~"},
{FWDSEARCH, "\033[[E"},
{FWDSEARCH, "\033[228z"},
{REVSEARCH, "\017b"},
{REVSEARCH, "\033[197z"},
{REVSEARCH, "\033[17~"},
{REVSEARCH, "\033[229z"},
{QUERYREPLACE, "\021\001"},
{QUERYREPLACE, "\033[1z"},
{RECORDING, "\017m"},
{RECORDING, "\033[199z"},
{RECORDING, "\033[32~"},
{RECORDING, "\033[19~"},
{RECORDING, "\033[231z"},
{RUNMEMORIZE, "\033[18~"},
{RUNMEMORIZE, "\017r"},
{RUNMEMORIZE, "\033[198z"},
{RUNMEMORIZE, "\033[31~"},
{RUNMEMORIZE, "\033[230z"},
{MANYRUNMEM, "\017\012"},
{DISPLAYMACRO, "\017\060"},
{DUMPKEYS, "\017+"},
{KEYSLOADUP, "\017@"},
{REPEATKEY, "\021\021"},
{SETEMACSMODE, "\013em"},
{SETWDSTARMODE, "\013ws"},
{SETWDPERFMODE, "\013wp"},
{SETMARK, "\013\002"},
{SWAPMARK, "\013\013"},
{REVEALMARK, "\013s"},
{COPYBLOCK, "\013c"},
{MOVEBLOCK, "\013m"},
{PASTEBLOCK, "\013p"},
{KILLNOTEPAD, "\017\030"},
{APPENDLINE, "\017\001"},
{ADDBUFFER, "\017\013"},
{QPUSHKEY, "\017\003"},
{QPUSHKEY, "\033[23~"}, /* F11 */
{QPOPKEY, "\017\026"},
{QZAPKEY, "\017\032"},
{OPTPUSHKEY, "\017\020"},
{OPTMATH, "\017i"},
{OPTHEX       , "\17H"},
{OPTOCT       , "\17O"},
{SETTABS, "\017\024"},
{SETDETAB, "\017\004"},
{SETTEXTTYPE, "\013\024"},
{REFORMKEY, "\002"},
{RUNHELP, "\017\010"},  /* ctrl-OH */
{RUNBHELP, "\021\010"}, /* ctrl-QH*/
{COMPLETEKEY  , "\17h"},
{COMPLETEKEY, "\033[192z"},
{MACROLIBRARY,  "\17e"},
{SETSTATUS, "\017\023"},
{SETAUTO, "\017\011"},
{SETHANGING, "\017\025"},
{WORDWRAP, "\017\027"},
{EXTENDEDCHAR, "\017\005"},
{FOLDSRCH, "\017\006"},
{BACKTOGGLE, "\017\002"},
{LOAD, "\013\014"},
{TSRKEY, "\013\032"},
{TSRKEY, "\033x"},
{TSRKEY, "\370"},
{SAVE_EXIT, "\013\030"},
{SAVE_NEXT, "\013\004"},
{BACKUP, "\013\023"},
{SAVEASKEY, "\013\027"},
{NAMECHANGE, "\013\016"},
{NEWLOAD, "\013\025"},
{RELOAD, "\013\05"},
{INJECT, "\013\022"},
{DSKFILES, "\013\006"},
{SCRAPBUFFER, "\013\021"},
{NEXTEDIT, "\014"},
{PREVEDIT, "\021\014"},
{SETBUFFER, "\013\001"},
{LFWDSEARCH, "\017F"},
{LREVSEARCH, "\017B"},
{ZEROTOKEN, "\200"},
{ZEROTOKEN, "\17z"},
{OPTMATHFLOAT, "\017j"},
{MATHFORMAT, "\017M"},
{OPTEVALEXPR, "\017k"},
{OPTEVALEXPR, "\033[24~"},
{BAILOUT, "\025\025"},
{PRINTFILE, "\013\020"},
{SETPRINTER, "\017P"},
{CASELOWER, "\017l"},
{CASELLOWER, "\017L"},
{CASEUPPER, "\017u"},
{CASELUPPER, "\017U"},
{CASECAPITAL, "\017C"},
{MOUSEPRESS, "\033[M"},
{MOUSERELEASEVALID, "\033[t"},
{MOUSERELEASEINVALID, "\033[T"},
{RUNPROGRAM, "\017\022"},
{RUNPROGRAM, "\033[[B"},
{RUNPROGRAM, "\033[12~"},
{RUNPROGRAM, "\033[225z"},
{RUNPROGRAM, "\033OQ"},
{RUNMYPROGRAM, "\017R"},
{READPIPE, "\021\020"},
{RUNBACKGROUND, "\017\021"},
{OPTIONSET, "\017\017"},
{LINEDRAWKEY, "\017\014"},
{MENUBOXSET, "\21b"},
{SHRINKWINDOW, "\017-"},
{VIDEOMODE, "\017v"},
{NEWWINSIZE, "\017W"},
{MACROKEY, "\017s"},
#endif
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
#if 0
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
        {-1           , ""              },      /* NULL pointer is the end */
#endif
#endif
        {-1           , ""              }       /* NULL pointer is the end */
};
int MAXKEYS= (sizeof(ourkeys)/sizeof(ourkeys[0]))-1;
